
var dragDest = null;
var dragSrc = null;
var dragStart = false;

var leftSide = 1;
var centerSide = 2;
var rightSide = 3;

var dockItems = 0;

var DockBase = new Class({
  initialize: function() {
    this.frame = null;
    this.className = "DockBase";
    this.name = "dockItem" + dockItems++;
    this.obj = eval(this.name + "=this");
    this.NotSave = false;
    this.color = "#FFFFFF";
    this.captureDragDrop = false;
    this.props = [];
  },

  destroy: function() {
    if (!this.frame) return false;
    try {
      this.destroyControls();
      this.frame.removeFromSuperview();
      delete this.frame;
      this.frame = null;
      return true;
    } catch(e) { }
  },

  free: function() {
    this.props = [];
  },

  destroyControls: function() {
    if (!this.frame) return false;
    try {
      if (this.frame.subviews["length"]) {
        try {
          while (this.frame.subviews.length > 0) {
            var o = this.frame.subviews[0];
            o.removeFromSuperview();
            delete o;
            o = null;
          }
        } catch(e) {}
      }
      return true;
    } catch(e) { }
  },

  load: function(xml) {
    for (var i = 0; i < this.props.length; i++) {
      try {
        this.props[i].load(xml);
      } catch (e) { 
        var prop = 'unknown';
        try {
          prop = this.props[i].name;
        } catch(e) {}
        print("\n  Couldn't load property '"+prop+"' of "+this.getName()+"\n  "+e);
      }
    }
    this.updateProps(true);
  },

  save: function() {
    var xml = "";
    for (var i = 0; i < this.props.length; i++) {
      try {
        if (xml) {
          xml = xml + "\n    " + this.props[i].save();
        } else {
          xml = this.props[i].save();
        }
      } catch (e) { 
        print("DockBase.save("+this.className+"), save of <property name='"
               +this.props[i].name+"'>"+this.props[i].value+"</property> failed\n"
               +"  type="+this.props[i].value.type+"\n  "+e);
      }
    }
    return xml;
  },

  getName: function() {
    return "<base>";
  },

  hasProps: function() {
    return (this.props.length > 0);
  },
  
  updateProps: function(loaded) {
  },

  showProps: function() {
    if (this.props.length <= 0) return true;
    var ff = [];
    try {
      for (var i = 0; i < this.props.length; i++) {
        if (this.props[i].hidden) continue;
        this.props[i].getFormField(ff);
      }
    } catch (e) { 
      var prop = 'unknown';
      try {
        prop = this.props[i].name;
      } catch(e) {}
      print("DockBase.showProps, getFormField of prop '"
             + prop + "' failed\n  "+e);
      return false;
    }

    var res = form(ff, tr("Sensor Properties"), tr("Save"));
    if (res == null) {
      return false;
    }

    var n = 0;
    for (var i = 0; i < this.props.length; i++) {
      if (this.props[i].hidden) continue;
      try {
        this.props[i].set(res[n], res[n + 1], res[n + 2]);
      } catch (e) { 
        print("DockBase.showProps, set of prop '"
               +this.props[i].name+"' failed\n  "+e);
      }
      n += this.props[i].setParams;
    }
    
    var save = true;
    if (arguments.length > 0) {
      save = arguments[0];
    }
    if (save) {
      dockObj.save();
    }
    this.updateProps(false);
    return true;
  },

  getHint: function() {
    return "";
  },

  getSide: function() {
    var d = dockObj.find(this);
    if (d) {
      return d.side;
    }
    return -1;
  },

  getIndex: function() {
    var d = dockObj.find(this);
    if (d) {
      return d.index;
    }
    return -1;
  },

  setVisible: function(value) {
    this.visible = value;
    if (this.frame) {
      this.frame.visible = this.visible;
    }
  },

  updatePrefs: function() {

  },

  updateColor: function() {
    var value = preferences.sensorsColor.value;
    this.color = value;
  },

  wakeUp: function() {

  },

  loseFocus: function() {

  },

  makeElementInactive: function(element, value) {
    if (!element) return;
    switch (preferences.inactiveSensorMode.value) {
      case "colorize":
        element.colorize = value?preferences.inactiveSensorColor.value:"";
        break;
      case "opacity":
        element.opacity = value?parseInt(preferences.inactiveSensorOpacity.value):255;
        break;
    }
  },

  resetElementInactive: function(element) {
    if (!element) return;
    element.colorize = "";
    element.opacity = 255;
  },

  setLeft: function(value) {
    if (!this.frame) return;
    this.frame.hOffset = value;
  },

  setTop: function(value) {
    if (!this.frame) return;
    this.frame.vOffset = value;
  },

  getLeft: function() {
    return this.frame.hOffset;
  },

  getWidth: function() {
    if (this.frame) {
      return this.frame.width;
    }
    return 0;
  },

  createControls: function() {
    if (!this.frame) {
      this.frame = new Frame(mainWindow);
      this.frame.window = mainWindow;
      this.frame.hAlign = "left";
      this.frame.vAlign = "top";

      this.frame.onMouseDown = this.mouseDown;
      this.frame.onMouseDrag = this.mouseDrag;
      this.frame.onMouseUp = this.mouseUp;
      this.frame.onMouseEnter = this.mouseEnter;
      this.frame.onMouseExit = this.mouseExit;
      this.frame.onMultiClick = this.multiClick;
      this.frame.onContextMenu = this.contextMenu;
      if (this.captureDragDrop) {
        this.frame.onDragEnter = function() {this.opacity -= 100;}
        this.frame.onDragExit = function() {this.opacity += 100;}
        this.frame.onDragDrop = this.dragDrop; 
      }
    }
    return (this.frame != null);
  },

  recreateControls: function() {
    suppressUpdates();
    try {
      this.destroyControls();
      this.createControls();
      dockObj.align();
    } finally {
      resumeUpdates();
    }
  },

  mouseDown: function() {
    if (!dockObj.locked || system.event.altKey) {
      if (!dockObj.locked) {
        dragStart = true;
      }
      this.opacity -= 100;
    }
    if (dragStart) {
      var t = dockObj.findFrameObject(this);
      if (t && t.hideHint()) {
        dockObj.hint.hide();
      }
    }
  },
  mouseDrag: function() {
    if (dragDest && !dockObj.locked) {
      if (dragDest.frame != this) {
        var d = dockObj.find(dragDest);
        if (d) {
          var dropSide = rightSide;
          var x = (system.event.hOffset - dragDest.frame.hOffset);
          if (x <= (dragDest.frame.width / 2)) {
            dropSide = leftSide;
          }
          v = mainWindow.height - placer.srcHeight - 3;
          if (placer.vOffset != v) {
            placer.vOffset = v;
          }
          var x = -1;
          if (dropSide == leftSide) {
            x = dragDest.frame.hOffset - 8;
          } else {
            x = dragDest.frame.hOffset + dragDest.frame.width + 2;
          }
          if (x <= 0) {
            x = 1;
          }
          if ((x + placer.width) >= background.width) {
            x = background.width - placer.width - 1;
          }
          if ((x != -1) && (placer.hOffset != x)) {
            placer.hOffset = x;
          }
          if (!placer.visible) {
            placer.visible = true;
          }
        }
      } else {
        placer.visible = false;
      }
    } else {
      var w3 = Math.round(mainWindow.width / 3);
      v = mainWindow.height - placer.srcHeight - 3;
      if ((system.event.hOffset < w3) && (dockObj.left.countInstance(DockBase) <= 0)) {
        if (placer.vOffset != v) {
          placer.vOffset = v;
        }
        placer.hOffset = 2;
        if (!placer.visible) {
          placer.visible = true;
        }
      } else
      if ((system.event.hOffset > w3) && (system.event.hOffset < (w3 * 2)) && (dockObj.center.countInstance(DockBase) <= 0)) {
        if (placer.vOffset != v) {
          placer.vOffset = v;
        }
        placer.hOffset = Math.round(mainWindow.width / 2);
        if (!placer.visible) {
          placer.visible = true;
        }
      } else
      if ((system.event.hOffset > (w3 * 2)) && (dockObj.right.countInstance(DockBase) <= 0)) {
        if (placer.vOffset != v) {
          placer.vOffset = v;
        }
        placer.hOffset = mainWindow.width - 2 - placer.width;
        if (!placer.visible) {
          placer.visible = true;
        }
      } else
      
      placer.visible = false;
    }
  },
  mouseUp: function() {
    if (dockObj.locked && system.event.altKey) {
      this.opacity += 100;
      var t = dockObj.findFrameObject(this);
      // Click handler
      if (t) {
        t.doClick();
      }
      return;
    }
    if (!dockObj.locked) {
      dragStart = false;
      this.opacity += 100;
      placer.visible = false;
      if (dragDest) {
        var t = dockObj.findFrameObject(this);
        // drop after dragDest
        if (dragDest.frame == this) {
          // Click handler
          if (t) {
            dragStart = false;
            t.doClick();
          }
          return;
        }
        if (t) {
          var s = dockObj.find(dragSrc);
          var d = dockObj.find(dragDest);
          if (s && d) {
            var dropSide = rightSide;
            var x = system.event.hOffset - dragDest.frame.hOffset;
            if (x <= dragDest.frame.width / 2) {
              dropSide = leftSide;
            }
            var i;
            if ((s.index < d.index) && (s.side == d.side)) {
              i = (dropSide == leftSide) ? d.index - 1 : d.index;
            } else {
              i = (dropSide == leftSide) ? d.index : d.index + 1;
            }
            dockObj.remove(t);
            dockObj.insert(d.side, i, t);
            dockObj.save();
          }
        }
        dragDest = null;
      } else {
        var dropSide = -1;
        var w3 = Math.round(mainWindow.width / 3);
        if ((system.event.hOffset < w3) && (dockObj.left.countInstance(DockBase) <= 0)) {
          dropSide = leftSide;
        } else
        if ((system.event.hOffset > w3) && (system.event.hOffset < (w3 * 2)) && (dockObj.center.countInstance(DockBase) <= 0)) {
          dropSide = centerSide;
        } else
        if ((system.event.hOffset > (w3 * 2)) && (dockObj.right.countInstance(DockBase) <= 0)) {
          dropSide = rightSide;
        }

        if (dropSide != -1) {
          var t = dockObj.findFrameObject(this);
          if (t) {
            dockObj.remove(t);
            dockObj.add(dropSide, t);
            dockObj.save();
          }
        }
      }
    }
  },
  mouseEnter: function() {
    dragDest = dockObj.findFrameObject(this);

    if (!dragStart && dockObj.isPopupsEnabled()) {
      dragSrc = dragDest;
      var t = dockObj.findFrameObject(this);
      if (t) {
        var y = (parseInt(preferences.position.value) == 2)?(mainWindow.vOffset + dockObj.y):dockObj.h;
        if (t.showHint(this.hOffset + Math.round(this.width / 2), y)) {
          var hintText = t.getHint();
          if (hintText != "") {
            dockObj.hint.show(this.hOffset + Math.round(this.width / 2) - 6, y, hintText);
          }
        }

        t.doMouseEnter();
      }
    }
  },
  mouseExit: function() {
    dragDest = null;

    var t = dockObj.findFrameObject(this);
    if (t) {
      if (!dragStart) {
        dragSrc = null;
        if (t.hideHint()) {
          dockObj.hint.hide();
        }
      }

      t.doMouseExit();
    }
  },

  multiClick: function() {
    var t = dockObj.findFrameObject(this);
    if (t) {
      t.doMultiClick();
    }
  },
  
  dragDrop: function() {
    var t = dockObj.findFrameObject(this);
    if (t) {
      t.doDragDrop();
    }
  },

  doMouseEnter: function() {

  },

  doMouseExit: function() {

  },

  doClick: function() {
    this.hideHint();
  },

  doMultiClick: function() {
  
  },
  
  doDragDrop: function(data) {
    return true;
  },

  showHint: function(x, y) {
    return true;
  },

  hideHint: function() {
    return true;
  },

  sensorMenuItems: function(items) {

  },

  contextMenu: function() {
    var items = [];

    items[0] = new MenuItem();
    items[0].title = tr("New sensor...");

    var t = dockObj.findFrameObject(this);
    if (t) {

      // TODO: hide hint if context menu invoked
      if (t.hint) {
        dockObj.hint.hide();
      }
      
      if (preferences.advancedNewMenu.value == 1) {
        createNewMenu(items[0], t.getSide(), t);
      } else {
        if (parseInt(preferences.useClassicNewDlg.value) == 1) {
          items[0].onSelect = newSensor.pass([t.getSide(), t.obj.name, t.getIndex()]);
        } else {
          items[0].onSelect = newSensorWin.pass([t.getSide(), t.obj.name, t.getIndex()]);
        }
      }

      var i = items.length;
      items[i] = new MenuItem();
      items[i].title = tr("Sensor properties...");
      items[i].onSelect = t.showProps.bind(t);
      items[i].enabled = t.hasProps();
      i++;

      items[i] = new MenuItem();
      items[i].title = tr("Remove sensor");
      items[i].onSelect = dockObj.deleteItem.bind(dockObj, t);
      i++;

      items[i] = new MenuItem();
      items[i].title = (system.platform == "windows")?"-":"(-";
      i++;

      if (parseInt(preferences.hideReadme.value) != 1) {
        items[i] = toolsItem = new MenuItem();
        items[i].title = tr("Tools");
        i++;

        subitem = new MenuItem();
        subitem.title = tr("Readme");
        subitem.onSelect = showReadme.pass();

        toolsItem.appendChild(subitem);

        /*items[i] = new MenuItem();
        items[i].title = (system.platform == "windows")?"-":"(-";
        i++;*/
      }

      items[i] = new MenuItem();
      items[i].title = tr("Lock");
      items[i].onSelect = function () { setLocked(!dockObj.locked); }.pass();
      items[i].checked = dockObj.locked;
      i++;

      items[i] = new MenuItem();
      items[i].title = tr("Popups");
      items[i].onSelect = function () { setPopups(!dockObj.popupsEnabled); }.pass();
      items[i].checked = dockObj.popupsEnabled;

      t.sensorMenuItems(items);
    }

    this.contextMenuItems = items;
  },

  setError: function() {

  },

  onAdd: function() {

  },

  playSoundNotify: function() {
    var sound = preferences.notifySound.value;
    if (sound != "") {
      play(sound, true);
    }
  },

  doNotify: function() {
    this.playSoundNotify();
  },

  openURL: function(url) {
    dockObj.openURL(url);
  }
});
