
var hintCount = 0;

var Hint = new Class({
  initialize: function() {
    this.win = null;
    this.text = "     ";
    this.hintText = null;
    this.name = "hintObj" + hintCount++;
    this.obj = eval(this.name + "=this");

    this.hiding = false;

    this.showTimer = new Timer();
    this.showTimer.ticking = false;
    this.showTimer.interval = 0.6;
    this.showTimer.onTimerFired = this.showNow.bind(this);

    this.hideTimer = new Timer();
    this.hideTimer.ticking = false;
    this.hideTimer.interval = 0.1;
    this.hideTimer.onTimerFired = this.hideNow.bind(this);
  },

  show: function(x, y) {
    this.hiding = false;

    this.hideTimer.ticking = false;

    var text = this.text;
    if (arguments.length > 2) {
      text = arguments[2];
    }

    if (!this.win) this.createWin();

    this.setText(text);

    this.win.width = this.leftSide.width + this.bk.width + this.rightSide.width;
    this.win.height = this.bk.height + this.pointer.height;

    var _x = mainWindow.hOffset + x - Math.round(this.win.width / 2) + 8;
    //var _y = mainWindow.vOffset + mainWindow.height - background.height - this.win.height;
    var _y = mainWindow.vOffset + mainWindow.height - dockObj.h - this.win.height;
    if (parseInt(preferences.position.value) == 1) {
      _y = mainWindow.vOffset + mainWindow.height;
    }

    //if (_x <= 0) { _x = 1; }
    if (_x <= 6) { _x = 7; }
    if ((_x + this.win.width) >= mainWindow.hOffset + mainWindow.width) { _x = mainWindow.hOffset + mainWindow.width - this.win.width - 7; }

    this.win.hOffset = _x;
    this.win.vOffset = _y;

    var p = mainWindow.hOffset + x - this.win.hOffset;
    if ((p + this.pointer.width + 3) > this.bk.width) {
      p = this.bk.width - this.pointer.width - 3;
    }
    this.pointer.hOffset = p;

    this.resize();

    //this.win.recalcShadow();

    // YWE 4.5 workaround
    if (!this.win.visible) {
      this.win.opacity = 0;
      if (parseInt(preferences.popupShadow.value) == 1) {
        this.win.shadow = true;
      }
      this.win.visible = true;
      updateNow();
      this.win.opacity = 0;

      this.showTimer.ticking = true;
    }

    /*if (!this.win.visible) {
      this.showTimer.ticking = true;
    }*/
  },

  showNow: function() {
    this.hideTimer.ticking = false;
    this.showTimer.ticking = false;

    // YWE 4.5 workaround
    if ((!this.win.visible || this.win.opacity < 255) && !this.hiding) {
      this.win.opacity = 255;
      //this.win.focus();
    }
    
    /*this.resize();
    if (!this.win.visible) {
      this.win.opacity = 0;
      if (parseInt(preferences.popupShadow.value) == 1) {
        this.win.shadow = true;
      }
      this.win.visible = true;
      updateNow();
      this.win.opacity = 255;
      //this.win.focus();
    }*/
  },

  hide: function() {
    this.hiding = true;
    this.showTimer.ticking = false;
    if (this.win) {
      if (this.win.visible) {
        this.hideTimer.ticking = true;
      }
    }
  },

  hideNow: function() {
    this.hiding = true;
    this.hideTimer.ticking = false;
    this.showTimer.ticking = false;
    if (!this.win) return;
    if (this.win.visible) {
      this.win.opacity = 0;
      this.win.visible = false;
      this.win.shadow = false;
      this.win.opacity = 255;
    }
  },

  setText: function(text) {
    this.text = text;
    if (this.text == "") {
      this.text = "     ";
    }
    if (this.hintText) {
      this.hintText.data = this.text;
      this.recalcTextArea(this.hintText);
      this.resize();
    }
  },

  createWin: function() {
    if (this.win) return;

    //this.win = new Window("hint");
    this.win = new Window();
    this.win.visible = false;
    //this.win.level = "floating";
    this.win.level = "topmost";
    this.win.onMouseUp = this.hideNow.bind(this);
    this.win.onMouseExit = this.hideNow.bind(this);

    this.hintText = new TextArea(mainWindow);
    this.hintText.window = this.win;
    this.hintText.editable = false;
    this.hintText.scrollbar = false;
    this.hintText.spellcheck = false;
    this.hintText.style.color = "#FFFFFF";
    this.hintText.style.fontFamily = "Arial, Helvetica";
    this.hintText.style.fontSize = "12px";
    this.hintText.style.fontWeight = "bold";
    this.hintText.hOffset = 6;
    this.hintText.vOffset = 6;
    this.hintText.data = this.text;
    this.hintText.zOrder = 2;

    // create graphics
    this.bk = new Image(mainWindow);
    this.bk.window = this.win;
    this.bk.src = "Resources/Hint/Fill.png";
    this.bk.colorize = "#000000";
    this.bk.opacity = 200;
    this.bk.zOrder = 1;

    this.pointer = new Image(mainWindow);
    this.pointer.window = this.win;
    this.pointer.src = "Resources/Hint/Pointer-Down.png";
    this.pointer.colorize = "#000000";
    this.pointer.opacity = 200;

    this.leftSide = new Image(mainWindow);
    this.leftSide.window = this.win;
    this.leftSide.src = "Resources/Hint/Fill.png";
    this.leftSide.colorize = "#000000";
    this.leftSide.opacity = 200;
    this.leftSide.hAlign = "left";
    this.leftSide.vAlign = "top";

    this.leftTop = new Image(mainWindow);
    this.leftTop.window = this.win;
    this.leftTop.src = "Resources/Hint/TopLeft.png";
    this.leftTop.colorize = "#000000";
    this.leftTop.opacity = 200;
    this.leftTop.hAlign = "left";
    this.leftTop.vAlign = "top";

    this.rightTop = new Image(mainWindow);
    this.rightTop.window = this.win;
    this.rightTop.src = "Resources/Hint/TopRight.png";
    this.rightTop.colorize = "#000000";
    this.rightTop.opacity = 200;
    this.rightTop.hAlign = "right";
    this.rightTop.vAlign = "top";

    this.rightSide = new Image(mainWindow);
    this.rightSide.window = this.win;
    this.rightSide.src = "Resources/Hint/Fill.png";
    this.rightSide.colorize = "#000000";
    this.rightSide.opacity = 200;
    this.rightSide.hAlign = "left";
    this.rightSide.vAlign = "top";

    this.leftBot = new Image(mainWindow);
    this.leftBot.window = this.win;
    this.leftBot.src = "Resources/Hint/BotLeft.png";
    this.leftBot.colorize = "#000000";
    this.leftBot.opacity = 200;
    this.leftBot.hAlign = "left";
    this.leftBot.vAlign = "bottom";

    this.rightBot = new Image(mainWindow);
    this.rightBot.window = this.win;
    this.rightBot.src = "Resources/Hint/BotRight.png";
    this.rightBot.colorize = "#000000";
    this.rightBot.opacity = 200;
    this.rightBot.hAlign = "right";
    this.rightBot.vAlign = "bottom";

    this.createChilds();

    this.updatePrefs();

    this.resize();
  },

  createChilds: function() {

  },

  updatePrefs: function() {
    if (this.win) {
      try {
        this.bk.colorize = this.pointer.colorize = this.leftSide.colorize =
          this.rightSide.colorize = this.leftTop.colorize = this.rightTop.colorize =
          this.leftBot.colorize = this.rightBot.colorize = preferences.popupColor.value;
        this.bk.opacity = this.pointer.opacity = this.leftSide.opacity =
          this.rightSide.opacity = this.leftTop.opacity = this.rightTop.opacity =
          this.leftBot.opacity = this.rightBot.opacity = parseInt(preferences.popupOpacity.value);
        this.hintText.data = "";
        //this.hintText.style.fontFamily = $font(preferences.popupTextFont.value);
        $$font(this.hintText, preferences.popupTextFont.value, preferences.popupTextFontStyle.value);
        //setFontStyle(this.hintText, preferences.popupTextFont.value);
        this.hintText.style.fontSize = parseInt(preferences.popupTextSize.value) + "px";
        this.hintText.style.color = preferences.popupTextColor.value;
      } finally {
        this.hintText.data = this.text;
        //this.hintText.style.fontWeight = "bold";
      }
    }
  },

  recalcTextArea: function(textarea) {
    if (system.platform == "windows") return;
    if (!textarea) return;
    var s = textarea.data;
    var lines = s.split("\n");
    var maxColumns = 0;
    var maxLines = lines.length;
    for (var i = 0; i < lines.length; i++) {
      maxColumns = Math.max(maxColumns, lines[i].length);
    }
    if (maxColumns <= 5) { maxColumns = 20; }
    if (maxLines <= 0) { maxLines = 1; }
    textarea.columns = maxColumns + 1;
    textarea.lines = maxLines;
  },

  resize: function() {
    suppressUpdates();
    try {
      if (parseInt(preferences.position.value) == 1) {
        this.hintText.vOffset = 6 + this.pointer.height;
        this.pointer.src = "Resources/Hint/Pointer-Up.png";
      } else {
        this.hintText.vOffset = 6;
        this.pointer.src = "Resources/Hint/Pointer-Down.png";
      }

      // resize
      this.bk.hOffset = this.hintText.hOffset;
      this.bk.vOffset = this.hintText.vOffset - 6;
      this.bk.width = this.hintText.width;
      this.bk.height = this.hintText.height + 12;

      this.doResize();
      if (this.bk.width < 30) {
        this.bk.width = 30;
      }
      if (this.bk.height < 20) {
        this.bk.height = 20;
      }

      if (parseInt(preferences.position.value) == 1) {
        this.pointer.vOffset = 0;
      } else {
        this.pointer.vOffset = this.bk.vOffset + this.bk.height;
      }

      this.leftTop.hOffset = 0;
      this.leftTop.vOffset = this.bk.vOffset;

      this.rightTop.hOffset = this.bk.hOffset + this.bk.width + this.rightTop.width;
      this.rightTop.vOffset = this.bk.vOffset;

      this.leftBot.hOffset = 0;
      this.leftBot.vOffset = this.bk.vOffset + this.bk.height;

      this.rightBot.hOffset = this.bk.hOffset + this.bk.width + this.rightBot.width;
      this.rightBot.vOffset = this.bk.vOffset + this.bk.height;

      this.leftSide.hOffset = 0;
      this.leftSide.vOffset = this.leftTop.vOffset + this.leftTop.height;
      this.leftSide.height = this.bk.height - this.leftTop.height - this.leftBot.height;

      this.rightSide.hOffset = this.bk.hOffset + this.bk.width;
      this.rightSide.vOffset = this.rightTop.vOffset + this.rightTop.height;
      this.rightSide.height = this.bk.height - this.rightTop.height - this.rightBot.height;
    } finally {
      resumeUpdates();
    }
  },

  doResize: function() {

  },

  isVisible: function() {
    return this.win.visible && (this.win.opacity == 255);
  }

});
