/**
 * Notification popup class
 * 
 * @author Andy Chentsov
 */

var notifyCount = 0;

// Notify Corner Const
var ncLeft     = 1;
var ncRight    = 2;

var Notify = new Class({

  getOptions: function(){
    return {
      //id: new Date().valueOf(),
      id: notifyCount,
      icon: "Resources/Icons/Info.png",
      title: "Notification",
      text: "",
      color: "#FFFFFF",
      titleColor: "#006CA3",
      textColor: "#000000",
      opacity: 210,
      corner: ncRight,
      onBeforeShow: Class.empty, 
      onShow: Class.empty, 
      onBeforeHide: Class.empty, 
      onHide: Class.empty,
      onPreview: Class.empty 
    };
  },

  initialize: function(data) {
    this.name = "notifyObj" + notifyCount++;
    this.obj = eval(this.name + "=this");
    this.win = null;
    this.width = 220;
    this.height = 50;
    this.vOffset = 0;
    this.previewWidth = 7;
    this.animation = null;
    this.previewed = false;
    this.setOptions(this.getOptions(), data);
  },
  
  destroy: function() {
    if (this.animation) this.animation.kill();
    if (this.timer) this.timer.ticking = false;
    if (this.win) {
      try {
        /*if (this.win.subviews["length"]) {
          try {
            while (this.win.subviews.length > 0) {
              var o = this.win.subviews[0];
              o.removeFromSuperview();
              delete o;
              o = null;
            }
          } catch(e) {}
        }*/

        var item = this.win.firstChild;
        while (item) {
          var next = item.nextSibling;
          this.win.removeChild(item);
          delete item;
          item = next;
        }

        this.win.visible = false;
        this.win.opacity = 0;
        delete this.win;
        this.win = null;
        return true;
      } catch(e) {}
    }
  },
  
  createWin: function() {
    if (this.win) this.destroy();
    
    //this.win = new Window("notify" + this.options.id);
    this.win = new Window();
    this.win.visible = false;
    //this.win.level = "floating";
    this.win.level = "topmost";
    this.win.shadow = true;
    //this.win.onMouseUp = this.obj.name + ".hide();";

    this.frame = new Frame(this.win);
    this.frame.window = this.win;
    this.frame.onMouseUp = this.hide.bind(this);
    
    // create graphics
    this.bk = new Image(mainWindow);
    this.frame.addSubview(this.bk);
    this.bk.src = "Resources/Hint/Fill.png";
    this.bk.colorize = "#000000";
    this.bk.opacity = this.options.opacity;
    this.bk.zOrder = 1;

    if (this.options.corner == ncRight) {
      this.leftSide = new Image(mainWindow);
      this.frame.addSubview(this.leftSide);
      this.leftSide.src = "Resources/Hint/Fill.png";
      this.leftSide.colorize = "#000000";
      this.leftSide.opacity = this.options.opacity;
      this.leftSide.hAlign = "left";
      this.leftSide.vAlign = "top";
      this.leftSide.zOrder = 1;
  
      this.leftTop = new Image(mainWindow);
      this.frame.addSubview(this.leftTop);
      this.leftTop.src = "Resources/Hint/TopLeft.png";
      this.leftTop.colorize = "#000000";
      this.leftTop.opacity = this.options.opacity;
      this.leftTop.hAlign = "left";
      this.leftTop.vAlign = "top";
      this.leftTop.zOrder = 1;
  
      this.leftBot = new Image(mainWindow);
      this.frame.addSubview(this.leftBot);
      this.leftBot.src = "Resources/Hint/BotLeft.png";
      this.leftBot.colorize = "#000000";
      this.leftBot.opacity = this.options.opacity;
      this.leftBot.hAlign = "left";
      this.leftBot.vAlign = "bottom";
      this.leftBot.zOrder = 1;
    }

    if (this.options.corner == ncLeft) {
      this.rightTop = new Image(mainWindow);
      this.frame.addSubview(this.rightTop);
      this.rightTop.src = "Resources/Hint/TopRight.png";
      this.rightTop.colorize = "#000000";
      this.rightTop.opacity = this.options.opacity;
      this.rightTop.hAlign = "right";
      this.rightTop.vAlign = "top";
      this.rightTop.zOrder = 1;
  
      this.rightSide = new Image(mainWindow);
      this.frame.addSubview(this.rightSide);
      this.rightSide.src = "Resources/Hint/Fill.png";
      this.rightSide.colorize = "#000000";
      this.rightSide.opacity = this.options.opacity;
      this.rightSide.hAlign = "left";
      this.rightSide.vAlign = "top";
      this.rightSide.zOrder = 1;
  
      this.rightBot = new Image(mainWindow);
      this.frame.addSubview(this.rightBot);
      this.rightBot.src = "Resources/Hint/BotRight.png";
      this.rightBot.colorize = "#000000";
      this.rightBot.opacity = this.options.opacity;
      this.rightBot.hAlign = "right";
      this.rightBot.vAlign = "bottom";
      this.rightBot.zOrder = 1;
    }
    
    this.icon = new Image(mainWindow);
    this.frame.addSubview(this.icon);
    this.icon.src = this.options.icon;
    this.icon.width = 48;
    this.icon.height = 48;
    this.icon.hOffset = (this.options.corner == ncRight)?this.leftSide.width:5;
    this.icon.vOffset = (this.options.corner == ncRight)?(this.leftTop.height + 5):(this.rightTop.height + 5);
    this.icon.zOrder = 2;

    this.caption = new Text(mainWindow);
    this.frame.addSubview(this.caption);
    this.caption.hOffset = this.icon.hOffset + this.icon.width + 5;
    this.caption.vOffset = this.icon.vOffset + 12;
    this.caption.style.fontSize = "13px";
    this.caption.style.fontWeight = "bold";
    this.caption.style.color = this.options.titleColor;
    this.caption.zOrder = 2;
    
    this.text = new TextArea(mainWindow);
    this.frame.addSubview(this.text);
    this.text.hOffset = this.icon.hOffset + this.icon.width;
    this.text.vOffset = this.caption.vOffset + 5;
    this.text.style.fontSize = "12px";
    this.text.editable = false;
    this.text.scrollbar = false;
    this.text.style.color = this.options.textColor;
    this.text.zOrder = 2;
  },
  
  recalcTextArea: function(textarea) {
    if (system.platform == "windows") return;
    if (!textarea) return;
    var s = textarea.data;
    var lines = s.split("\n");
    var maxColumns = 0;
    var maxLines = lines.length;
    for (var i = 0; i < lines.length; i++) {
      maxColumns = Math.max(maxColumns, lines[i].length);
    }
    if (maxColumns <= 5) { maxColumns = 20; }
    if (maxLines <= 0) { maxLines = 1; }
    textarea.columns = maxColumns + 1;
    textarea.lines = maxLines;
  },
  
  resize: function() {
    //suppressUpdates();
    try {
      this.bk.hOffset = (this.options.corner == ncRight)?this.leftSide.width:0;
      this.bk.vOffset = (this.options.corner == ncRight)?this.leftTop.height:this.rightTop.height;
      this.bk.width = this.width;
      this.bk.height = Math.max(
        Math.max(this.height, this.icon.height + 12),
        this.caption.height + 7 + this.text.height + ( (this.options.corner == ncRight)?this.leftBot.height:this.rightBot.height )
      );

      this.caption.width = this.bk.width - this.caption.hOffset - 5;
      
      this.text.width = this.bk.width - this.text.hOffset - 5;

      if (this.options.corner == ncRight) {      
        this.leftTop.hOffset = 0;
        this.leftTop.vOffset = this.bk.vOffset;
  
        this.leftBot.hOffset = 0;
        this.leftBot.vOffset = this.bk.vOffset + this.bk.height;
  
        this.leftSide.hOffset = 0;
        this.leftSide.vOffset = this.leftTop.vOffset + this.leftTop.height;
        this.leftSide.height = this.bk.height - this.leftTop.height - this.leftBot.height;
      }

      if (this.options.corner == ncLeft) {
        this.rightTop.hOffset = this.bk.hOffset + this.bk.width + this.rightTop.width;
        this.rightTop.vOffset = this.bk.vOffset;
  
        this.rightBot.hOffset = this.bk.hOffset + this.bk.width + this.rightBot.width;
        this.rightBot.vOffset = this.bk.vOffset + this.bk.height;
  
        this.rightSide.hOffset = this.bk.hOffset + this.bk.width;
        this.rightSide.vOffset = this.rightTop.vOffset + this.rightTop.height;
        this.rightSide.height = this.bk.height - this.rightTop.height - this.rightBot.height;
      }

      // ---
      
      this.win.width = this.bk.width + ( (this.options.corner == ncRight)?this.leftSide.width:this.rightSide.width );
      if (this.options.corner == ncRight) {
        this.win.height = this.bk.height + this.leftTop.height + this.leftBot.height;
      } else {
        this.win.height = this.bk.height + this.rightTop.height + this.rightBot.height;
      }
      if (parseInt(preferences.position.value) == 1) {
        this.win.vOffset = screen.availTop + 40;
      }
      if (parseInt(preferences.position.value) == 2) {
        this.win.vOffset = screen.availHeight - this.win.height - 40;
      }
    } finally {
      //resumeUpdates();
    }    
  },

  colorize: function(color) {
    if (!this.win) return;
    this.bk.colorize = color;
    
    if (this.options.corner == ncRight) {
      this.leftSide.colorize = color;
      this.leftTop.colorize = color;
      this.leftBot.colorize = color;
    }
    
    if (this.options.corner == ncLeft) {
      this.rightSide.colorize = color;    
      this.rightTop.colorize = color;    
      this.rightBot.colorize = color;
    }    
  },

  showDone: function() {
    this.animation = null;
    this.startCloseTimer();
    this.fireEvent('onShow', this);
  },

  _show: function() {
    this.fireEvent('onBeforeShow', this);
    var pos = {start: 0, end: 0};
    if (this.options.corner == ncRight) {
      pos.start = screen.availWidth;
      pos.end = screen.availWidth - this.win.width;
    }
    if (this.options.corner == ncLeft) {
      pos.start = -(this.win.width) + (this.previewed?this.previewWidth:0);
      pos.end = 0 /* YWE4 Bug */ -10;
    }
    if (this.previwed) {
      pos.start = this.win.hOffset;      
    }
    this.win.hOffset = pos.start;
    
    if (!this.win.visible && !this.previwed) {
      this.win.opacity = 0;
      this.win.visible = true;
      this.win.opacity = 255;
    }

    this.vOffset = this.win.vOffset; 
    if (this.animation) this.animation.kill();
    this.animation = new MoveAnimation(this.win, pos.end, this.win.vOffset, 500, animator.kEaseOut, this.showDone.bind(this));
    //this.animation = new MoveAnimation(this.win, pos.end, this.win.vOffset, 500, animator.kEaseOut);
    animator.runUntilDone(this.animation);
    //this.showDone();
  },

  hideDone: function() {
    this.animation = null;
    this.previewed = false;
    this.win.opacity = 0;
    this.win.visible = false;
    this.fireEvent('onHide', this);
  },

  hide: function() {
    this.fireEvent('onBeforeHide', this);
    if (this.timer) this.timer.ticking = false;
    if (this.animation) this.animation.kill();
    var pos = 0;
    if (this.options.corner == ncRight) {
      pos = screen.availWidth/* + 30*/;
    }
    if (this.options.corner == ncLeft) {
      pos = -(/*30 + */this.win.width);

      /* YWE4 Bug */
      this.win.hOffset -= 10;
    }
    this.win.vOffset = this.vOffset;
    this.animation = new MoveAnimation(this.win, pos, this.vOffset, 500, animator.kEaseIn, this.hideDone.bind(this));
    //this.animation = new MoveAnimation(this.win, pos, this.win.vOffset, 500, animator.kEaseIn);
    animator.runUntilDone(this.animation);
    //this.hideDone();
  },

  previewedDone: function() {
    this.animation = null;
    this.previewed = true;
  },

  preview: function(data) {
    if (data) {
      this.options.extend(data);
    }
    this.createWin();

    if ((this.caption.data != this.options.title) ||
        (this.text.data != this.options.text)) {
      this.caption.data = this.options.title;
      this.text.data = this.options.text;
      this.recalcTextArea(this.text);
  
      this.resize();
    }
    this.colorize(this.options.color);
    this.fireEvent('onPreview', this);

    var pos = {start: 0, end: 0};
    if (this.options.corner == ncRight) {
      pos.start = screen.availWidth;
      pos.end = screen.availWidth - this.previewWidth;
    }
    if (this.options.corner == ncLeft) {
      pos.start = -(this.win.width);
      pos.end = pos.start + this.previewWidth;
    }
    this.win.hOffset = pos.start;
    
    this.win.opacity = 0;
    this.win.visible = true;
    this.win.opacity = 255;
    
    if (this.animation) this.animation.kill();
    this.animation = new MoveAnimation(this.win, pos.end, this.win.vOffset, 300, animator.kEaseOut, this.previewedDone.bind(this));
    animator.runUntilDone(this.animation);
  },
  
  show: function(data) {
    if (data) {
      this.options.extend(data);
    }
    this.createWin();

    if ((this.caption.data != this.options.title) ||
        (this.text.data != this.options.text)) {
      this.caption.data = this.options.title;
      this.text.data = this.options.text;
      this.recalcTextArea(this.text);
  
      this.resize();
    }
    this.colorize(this.options.color);
    this._show();
  },
  
  startCloseTimer: function() {
    if (!this.timer) {
      this.timer = new Timer();
      this.timer.interval = 7;
      this.timer.onTimerFired = this.hide.bind(this);
    }
    this.timer.ticking = true;
  }/*,

  updatePrefs: function(prefs) {
    this.options.color = prefs.color;
    this.options.titleColor = prefs.titleColor;
    this.options.textColor = prefs.textColor;
    this.options.opacity = prefs.opacity;
    this.options.corner = prefs.corner;
    //
    if (this.bk) this.bk.opacity = this.options.opacity;
  }*/
  
});

Notify.implement(new Events);
Notify.implement(new Options);
