
function createNewMenu(items, side) {
  var target = null;
  if (arguments.length > 2) {
    target = arguments[2];
  }

  var sortedSensors = getSortedSensors();
  /*var item = new MenuItem();
  item.title = "New sensor";*/
  for (var i = 0; i < sortedSensors.length; i++) {
    var subitem = new MenuItem();
    subitem.title = sortedSensors[i].name;
    if (!target) {
      subitem.onSelect = newSensorEx.pass([side, sortedSensors[i].className]);
    } else {
      subitem.onSelect = newSensorEx.pass([side, sortedSensors[i].className, target.obj.name, target.getIndex()]);
    }
    items.appendChild(subitem);
  }
  //items.push(item);
}

function dockContextMenu() {
  var items = [];

  var newSide = leftSide;
  var w3 = (background.width / 3);
  if (system.event.hOffset < w3) {
    newSide = leftSide;
  } else if ((system.event.hOffset >= w3) && (system.event.hOffset <= (w3 * 2))) {
    newSide = centerSide;
  } else {
    newSide = rightSide;
  }

  items[0] = new MenuItem();
  items[0].title = tr("New sensor...");
  if (preferences.advancedNewMenu.value == 1) {
    createNewMenu(items[0], newSide);
  } else {
    if (parseInt(preferences.useClassicNewDlg.value) == 1) {
      items[0].onSelect = newSensor.pass([newSide]);
    } else {
      items[0].onSelect = newSensorWin.pass([newSide]);
    }
  }

  var item = new MenuItem();
  item.title = (system.platform == "windows")?"-":"(-";
  items.push(item);

  var item = toolsItem = new MenuItem();
  item.title = tr("Tools");
  items.push(item);

  var item = new MenuItem();
  item.title = tr("Import Sensors");
  item.onSelect = dock.importDlg.bind(dock);
  toolsItem.appendChild(item);

  var item = new MenuItem();
  item.title = tr("Export Sensors");
  item.onSelect = dock.exportDlg.bind(dock);
  toolsItem.appendChild(item);

  if (parseInt(preferences.hideReadme.value) != 1) {
    var item = new MenuItem();
    item.title = (system.platform == "windows")?"-":"(-";
    toolsItem.appendChild(item);

    var item = new MenuItem();
    item.title = tr("Readme");
    item.onSelect = showReadme.pass();
    toolsItem.appendChild(item);
  }

  /*var item = new MenuItem();
  item.title = (system.platform == "windows")?"-":"(-";
  items.push(item);*/

  var item = new MenuItem();
  item.title = tr("Lock");
  item.onSelect = function() { setLocked(!dock.locked); }.pass();
  item.checked = dock.locked;
  items.push(item);

  var item = new MenuItem();
  item.title = tr("Popups");
  item.onSelect = function() { setPopups(!dock.popupsEnabled); }.pass();
  item.checked = dock.popupsEnabled;
  items.push(item);

  background.contextMenuItems = items;
}