
var networkProviderMacOS = networkProvider.extend({

  getList: function() {
    var i;
    var description;
    var devs = {};

    var data = runCommand("system_profiler SPNetworkDataType");
    data = data.split("\n");

    //     AirPort:
    //       BSD Device Name: en1
    this.devices = [];
    for (i = 1; i < data.length; i++) {
      var label = data[i].match(/\s*(.*)\s*:$/);
      if (label) {
        description = label[1]; // "Airport"
        continue;
      }
      var name = data[i].match(/\s*(Interface|BSD Device Name)\s*:\s*(.*)\s*/);
      if (name) {
        devs[name[2]] = description; // "en1"
      }
    }

    var ifs = runCommand("netstat -i");
    ifs = ifs.split("\n");

    // Name  Mtu   Network       Address            Ipkts Ierrs    Opkts Oerrs  Coll
    // en0   1500  <Link#4>    00:03:93:45:3c:d0        0     0        0     0     0
    for (i = 1; i < ifs.length; i++) {
      var tmp = ifs[i].replace(/\s+/g, " ");
      tmp = tmp.split(" ");
      if (devs[tmp[0]]) {
        var mac_addr = tmp[3].match(/^..:..:..:..:..:..$/);
        var ref = new RegExp("^"+tmp[0]+"\\s+");
        this.devices.push({name: devs[tmp[0]], mac: mac_addr, bps: 100000000, ref: ref, mtu: tmp[1]});
        devs[tmp[0]] = null;
      }
    }
    this.parent();
  },

  getIO: function() {
    if (!this.current.device && this.current.name) {
      this.setCurrentDevice(this.current.name);
    }
    if (this.current.device) {
      var re = this.current.device.ref;
      var ifs = runCommand("netstat -i");
      ifs = ifs.split("\n");
      for (i = 1; i < ifs.length; i++) {
        if (re.test(ifs[i])) {
          var tmp = ifs[i].replace(/\s+/g, " ");
          tmp = tmp.split(" ");
          return { bytesIn: tmp[4] * this.current.device.mtu,
                   bytesOut: tmp[6] * this.current.device.mtu };
        }
      }
    }
    return this.parent();
  }

});
