
var networkProviderWin = networkProvider.extend({

  initialize: function() {
    this.parent();
    this.wakeUp();
  },

  getList: function() {
    // This is a horrible, horrible way to iterate through a loop...
    // Unfortunately, we don't really get a count of interfaces, so this is the best we can do
    try {
      this.devices = [];

      //var items = this.wmi.ExecQuery("Select * From Win32_NetworkAdapterConfiguration Where IPEnabled = 'True'");
      /*for (var i in items) {
        print(items[i]);
      }*/
      //print(items);

      for (var i = 1; i <= 64; i++) {
        var config = this.wmi.Get('Win32_NetworkAdapterConfiguration.Index=' + i).Properties_;

        //print(config.Item("Description").Value);

        if (config.Item("IPEnabled").Value) {
          var adapter = this.wmi.Get('Win32_NetworkAdapter.DeviceID=' + i).Properties_;
          var mac_addr = adapter.Item("MACAddress").Value
          if (mac_addr) {
            var ref = config.Item("Description").Value;

            ref = ref.replace(/\//g, "_")
            ref = ref.replace(/\(/g, "[");
            ref = ref.replace(/\)/g, "]");
            ref = ref.replace(/#/g, "_");
            
            var bps = this.wmi.Get('Win32_PerfRawData_Tcpip_NetworkInterface.name="' + ref + '"').Properties_.Item("CurrentBandwidth").Value;
            if (!isNaN(bps)) {
              var name = adapter.Item("Description").Value;
              //var ip_addr = config.Item("IPAddress").Value;
              this.devices.push({name: name, mac: mac_addr, bps: bps, ref: ref});
            }
          }
        }
      }
    } catch (e) { }
    this.parent();
  },
  
  getIO: function() {
    if (!this.current.device && this.current.name) {
      this.setCurrentDevice(this.current.name);
    }
    if (this.current.device) {
      var perf = this.wmi.Get('Win32_PerfRawData_Tcpip_NetworkInterface.name="' + this.current.device.ref + '"').Properties_;
      if (perf.Item("CurrentBandwidth").Value) {
        return { bytesIn: perf.Item("BytesReceivedPerSec").Value, 
                 bytesOut: perf.Item("BytesSentPerSec").Value };
      }
    }
    return this.parent();
  },
  
  wakeUp: function() {
    this.parent();
    this.WBEM = COM.createObject("WbemScripting.SWbemLocator.1");
    this.wmi = this.WBEM.ConnectServer(".", "root/cimv2");
    this.getList();
  }

});
