
var SwapFileInfo = new Class({
  initialize: function() {
    this.totalVirtual = 0;
    this.usedVirtual = 0;
    this.availVirtual = 0;
    this.load = 0;

    this.wmi = null;
    this.WBEM = null;
    this.swapFiles = null;
    if (system.platform == "windows") {
      // Get page files for later usage with WMI.
      this.initWMI();
    }
  },
  
  initWMI: function() {
    try {
      this.swapFiles = runCommand("cscript.exe /nologo Scripts/Utils/SwapGraph_WMI.js");
      this.swapFiles = this.swapFiles.split("\n");
      for (var i = 0; i < this.swapFiles.length; i++) {
        this.swapFiles[i] = this.swapFiles[i].replace(/\\/,"\\\\");
      }

      // Init WMI.
      this.WBEM = COM.createObject("WbemScripting.SWbemLocator.1");
      this.wmi = this.WBEM.ConnectServer(".", "root/cimv2");
    } catch(ex) {
      log("Couldn't get page files: " + ex.message);
      this.wmi = null;
      this.WBEM = null;
    }
  },
  
  getData: function() {
    if (this.wmi) {
      try {
        this.totalVirtual = 0;
        this.usedVirtual  = 0;

        for (var i = 0; i < this.swapFiles.length; i++) {
          var pageFile = this.wmi.Get('Win32_PageFileUsage.name="' + this.swapFiles[i] + '"').Properties_;
          this.totalVirtual += pageFile.Item("AllocatedBaseSize").Value * 1024 * 1024;
        this.usedVirtual += pageFile.Item("CurrentUsage").Value * 1024 * 1024;
        }
      } catch(ex) {
        log("Couldn't get page file data: " + ex.message);
        this.initWMI();
      }
      this.availVirtual = this.totalVirtual - this.usedVirtual;
    } else {
      this.totalVirtual = system.memory.totalVirtual;
      this.availVirtual = system.memory.availVirtual;
      this.usedVirtual = this.totalVirtual - this.availVirtual;
    }
    this.load = Math.round((this.totalVirtual - this.availVirtual) / this.totalVirtual * 100);
  },

  getHint: function() {
    var text = tr("Total Virtual: ") + trBytesToUI(this.totalVirtual) +
               tr("\nAvailable Virtual: ") + trBytesToUI(this.availVirtual) +
               tr("\nSwap Load: ") + this.load + "%";
    if (!dockObj.isLocked()) {
      if (system.platform == "macintosh") {
        text += tr("\n\nClick to open Activity Monitor");
      }
      else {
        text += tr("\n\nClick to open Task Manager");
      }
    }
    return text;
  }
});
