
var Informer = {};

String.prototype.pad = function(num) {
  var result = this;
  var sym = " ";
  if (arguments.length > 1) {
    sym = arguments[1];
  }
  while (result.length < num) {
    result = sym + result;
  }
  return result;
}

String.prototype.padRight = function(num) {
  var result = this;
  var sym = " ";
  if (arguments.length > 1) {
    sym = arguments[1];
  }
  while (result.length < num) {
    result += sym;
  }
  return result;
}

if ("".trim == null) {
  String.prototype.trim = function() {
    return this.replace(/(^\s*)|(\s*$)/g, "");
  }
}

String.prototype.extractFileName = function() {
  var url = this;
  i = url.length
  while (i >= 0 && (url.substring(i, i + 1) != "/") && (url.substring(i, i + 1) != "\\")) {
    i--;
  }
  if (i > 0) {
    return url.substring(i + 1, url.length);
  } else return url;
}

/* for lazy coders */
function tr(s) {
  return widget.getLocalizedString(s);
}

/* format a float number f with n digits */
function formatFloat(f, n) {
  var text = String(Math.round(f));
  if (n > 0) {
    var d = 1;
    for (var i = 0; i < n; i++) {
      d *= 10;
    }
    f = Math.round(f * d);
    text = String(Math.floor(f / d)) + "." + String(f % d).pad(n, "0");
  }
  return text;
}

/* helper for trBytesToUI() and trBytesPerSecToUI() */ 
function formatByteValues(n, digits, units) {
 var txt;
 if (n >= 1099511627776) {
    n /= 1099511627776;
    txt = tr(units[0]);
  } else if (n >= 1073741824) {
    n /= 1073741824;
    txt = tr(units[1]);
  } else if (n >= 1048576) {
    n /= 1048576;
    txt = tr(units[2]);
  } else if (n >= 1024) {
    n /= 1024;
    txt = tr(units[3]);
  } else {
    if (n != 1) {
      txt = tr(units[4]);
    } else {
      txt = tr(units[5]);
    }
    if (digits < 0) {
      digits = 0;
    }
  }
  if (digits < 0) {
    if (n == 0) {
      txt = txt.replace(/%d/, "0");
    } else if (n < 10) {
      txt = txt.replace(/%d/, formatFloat(n, 2));
    } else if (n < 100) {
      txt = txt.replace(/%d/, formatFloat(n, 1));
    } else {
      txt = txt.replace(/%d/, formatFloat(n, 0));
    }
  } else {
    txt = txt.replace(/%d/, formatFloat(n, digits));
  }
  return txt;
}

/* like bytesToString but with localization of the byte units */
function trBytesToUI(n) {
  var units = ["%d TB", "%d GB", "%d MB", "%d KB", "%d bytes", "%d byte"];
  return formatByteValues(n, (arguments.length == 1) ? -1 : arguments[1], units);
}

function trBytesPerSecToUI(n) {
  var units = ["%d TB/s", "%d GB/s", "%d MB/s", "%d KB/s", "%d B/s", "%d B/s"];
  return formatByteValues(n, (arguments.length == 1) ? -1 : arguments[1], units);
}

Informer.importclass = function(cid) {
  var path = cid.replace(".", "/");
  var className = cid;
  var tmp = cid.split(".");
  if (tmp.length > 1) {
    className = tmp[tmp.length - 1];
  }
  try {
    var exist = (eval(className) != null);
  } catch(e) {
    var exist = false;
  }
  if (!exist) {
    include(path + ".js");
  }
}

// This code is in the public domain. Feel free to link back to http://jan.moesen.nu/
String.prototype.sprintf = function() {
  if (!arguments || arguments.length < 1 || !RegExp) {
    return;
  }
  var str = this;
  var re = /([^%]*)%('.|0|\x20)?(-)?(\d+)?(\.\d+)?(%|b|c|d|u|f|o|s|x|X)(.*)/;
  var a = b = [], numSubstitutions = 0, numMatches = 0;
  while (a = re.exec(str)) {
    var leftpart = a[1], pPad = a[2], pJustify = a[3], pMinLength = a[4];
    var pPrecision = a[5], pType = a[6], rightPart = a[7];
    
    //alert(a + '\n' + [a[0], leftpart, pPad, pJustify, pMinLength, pPrecision);

    numMatches++;
    if (pType == '%') {
            subst = '%';
    } else {
      if (numSubstitutions >= arguments.length) {
        print('Error! Not enough function arguments (' + (arguments.length - 1) + ', excluding the string)\nfor the number of substitution parameters in string (' + numSubstitutions + ' so far).');
      }
      var param = arguments[numSubstitutions];
      var pad = '';
      if (pPad && pPad.substr(0,1) == "'") pad = leftpart.substr(1,1);
      else if (pPad) pad = pPad;
      var justifyRight = true;
      if (pJustify && pJustify === "-") justifyRight = false;
      var minLength = -1;
      if (pMinLength) minLength = parseInt(pMinLength);
      var precision = -1;
      if (pPrecision && pType == 'f') precision = parseInt(pPrecision.substring(1));
      var subst = param;
           if (pType == 'b') subst = parseInt(param).toString(2);
      else if (pType == 'c') subst = String.fromCharCode(parseInt(param));
      else if (pType == 'd') subst = parseInt(param) ? parseInt(param) : 0;
      else if (pType == 'u') subst = Math.abs(param);
      else if (pType == 'f') subst = (precision > -1) ? Math.round(parseFloat(param) * Math.pow(10, precision)) / Math.pow(10, precision): parseFloat(param);
      else if (pType == 'o') subst = parseInt(param).toString(8);
      else if (pType == 's') subst = param;
      else if (pType == 'x') subst = ('' + parseInt(param).toString(16)).toLowerCase();
      else if (pType == 'X') subst = ('' + parseInt(param).toString(16)).toUpperCase();
      numSubstitutions++;
    }
    str = leftpart + subst + rightPart;
  }
  return str;
}

function $font(value) {
  if (value == "") return "";
  return "\"" + value + "\"";
}

function $$font(element, font, style) {
  element.style.fontFamily = $font(font);
  switch(style) {
    case "normal":
      element.style.fontWeight = "normal";
      element.style.fontStyle = "normal";
      break;
    case "bold":
      element.style.fontWeight = "bold";
      element.style.fontStyle = "normal";
      break;
    case "italic":
      element.style.fontWeight = "normal";
      element.style.fontStyle = "italic";
      break;
    case "bold italic":
      element.style.fontWeight = "bold";
      element.style.fontStyle = "italic";
      break;
  }
}

Object.prototype.copy = function() {
  return Object.extend({}, this);
}

function $absOffset(_element) {
  var point = {x: 0, y: 0};
  var element = _element;
  do {
    point.x += element.hOffset;
    point.y += element.vOffset;
    element = element.parentNode;
  } while(element.parentNode);
  if (_element.window) {
    point.x += _element.window.hOffset;
    point.y += _element.window.vOffset;
  }
  return point;
}

Object.prototype.extend = Object.extend;
