
function compareSensorNames(a, b) {
  return a.name < b.name ? -1 : (a.name > b.name ? 1 : 0);
}

function getSortedSensors() {
  var sortedSensors = [];
  for (var i = 0; i < dockFactory.items.length; i++) {
    sortedSensors.push({ name: dockFactory.items[i].name, 
                         className: dockFactory.items[i].className});
  } 
  sortedSensors.sort(compareSensorNames);
  return sortedSensors;
}

function newSensor(side) {
  var target = null;
  var targetIndex = -1;
  if (arguments.length > 1) {
    target = arguments[1];
  }
  if (arguments.length > 2) {
    targetIndex = arguments[2];
  }
  
  var sortedSensors = getSortedSensors();
  
  var ff = [];

  var f = new FormField();
  ff.push(f);
  f.title = "Sensor:";
  f.name = "kind";
  f.type = "popup";
  f.option = [];
  f.optionValue = [];
  for (var i = 0; i < sortedSensors.length; i++) {
    f.option.push(sortedSensors[i].name);
    f.optionValue.push(sortedSensors[i].className);
  }
  f.description = tr("Choose sensor to create on Informer dock");

  if (target) {
    var f = new FormField();
    ff.push(f);
    f.title = tr("Insert:");
    f.name = "place";
    f.type = "popup";
    f.option = [tr("before"), tr("after")];
    f.defaultValue = tr("after");
    f.description = tr("Insert new sensor before or after ") + "'" + target.getName() + "'";
  }

  var res = form(ff, tr("New sensor"), tr("Create"));
  if (res != null) {
    if (res.length > 1) {
      newSensorEx(side, res[0], target, targetIndex, res[1]);
    } else {
      newSensorEx(side, res[0], target, targetIndex);
    }
  }
}

function newSensorEx(side, className) {
  var place = tr("after");
  var target = null;
  var targetIndex = -1;
  var autoCreate = false;
  if (arguments.length > 2) {
    target = arguments[2];
  }
  if (arguments.length > 3) {
    targetIndex = arguments[3];
  }
  if (arguments.length > 4) {
    place = arguments[4];
  }
  if (arguments.length > 5) {
    autoCreate = arguments[5];
  }

  var sensor = eval("new " + className);
  var props = true;
  if (!autoCreate) {
    props = sensor.showProps();
  }
  if (props) {
    if (targetIndex != -1) {
      dock.insert(side, (place == tr("before"))?targetIndex:(targetIndex + 1), sensor);
      sensor.onAdd();
    } else {
      dock.add(side, sensor); 
    }
    if (!autoCreate) {
      dock.save();
    }
    return sensor;
  } else {
    delete sensor;
    sensor = null;
  }
  return null;
}
