
var readmeWin = null;

function Readme() {
  this.dynWin = null;
  this.win = null;
  this.bk = null;
  this.html = "";
  this.descHeight = 0;

  this.opacity = 160;
  this.onClose = function() {};
  this.name = "readmeObj";
  this.obj = eval(this.name + "=this");

  this.createWin = function() {
    if (this.win) return;

    this.dynWin = new dynWindow("Scripts/Windows/readme.xml", this, false);
    this.win = this.dynWin.element;
    this.win.hOffset = Math.round((screen.availWidth - this.win.width) / 2);
    this.win.vOffset = Math.round((screen.availHeight - this.win.height) / 3);
    if (parseInt(preferences.position.value) == 2) {
      this.win.vOffset *= 2;
    }

    this.scroller.vOffset = 15 + this.caption.height;
    this.frame.vOffset = this.scroller.vOffset;

    this.resize();

    // Render HTML here
    this.html = new MiniHTML(this.frame);
    // Setup default style
    //this.html.css["body"] = {fontFamily: "Calibri, \"Arial Narrow\", Arial", color: "#FFFFFF", fontSize: "13px"};
    this.html.css["body"] = {fontFamily: "\"Trebuchet MS\", \"Arial Narrow\", Arial", color: "#FFFFFF", fontSize: "12px"};
    this.html.css["a"] = {color: "#8EDDFF"};
    this.html.lineImage = "Resources/Hint/Fill.png";

    /*this.html.defaultTextFont = "Trebuchet MS";
    this.html.defaultTextSize = 12;
    this.html.defaultMonoTextFont = "Lucida Console";
    this.html.defaultLinkColor = "#8EDDFF";
    this.html.defaultLine = "Resources/Hint/Fill.png";
    //this.html.rightPadding = 15;*/
    var filename = "Resources/" + widget.locale.substr(0, 2) + "/Readme/Readme" + ((system.platform == "macintosh")?"-Mac":"-Win") + ".html";
    if (!filesystem.itemExists(filename)) {
      filename = "Resources/en/Readme/Readme" + ((system.platform == "macintosh")?"-Mac":"-Win") + ".html";
    }
    this.html.render(this.loadHTML(filename));

    this.win.recalcShadow();
  }

  this.loadHTML = function(filename) {
    try {
      return filesystem.readFile(filename);
    } catch(e) {
      return "Error loading readme.";
    }
  }

  this.resize = function() {
    suppressUpdates();
    try {
      // resize
      this.bk.hOffset = this.leftTop.srcWidth;
      this.bk.vOffset = this.leftTop.srcHeight;
      this.bk.width = this.win.width - this.leftTop.srcWidth - this.rightTop.srcWidth;
      this.bk.height = this.win.height - this.leftTop.srcHeight - this.rightTop.srcHeight;

      this.leftTop.hOffset = 0;
      this.leftTop.vOffset = this.bk.vOffset;

      this.rightTop.hOffset = this.bk.hOffset + this.bk.width + this.rightTop.width;
      this.rightTop.vOffset = this.bk.vOffset;

      this.leftBot.hOffset = 0;
      this.leftBot.vOffset = this.bk.vOffset + this.bk.height;

      this.rightBot.hOffset = this.bk.hOffset + this.bk.width + this.rightBot.width;
      this.rightBot.vOffset = this.bk.vOffset + this.bk.height;

      this.leftSide.hOffset = 0;
      this.leftSide.vOffset = this.leftTop.vOffset + this.leftTop.height;
      this.leftSide.height = this.bk.height - this.leftTop.height - this.leftBot.height;

      this.rightSide.hOffset = this.bk.hOffset + this.bk.width;
      this.rightSide.vOffset = this.rightTop.vOffset + this.rightTop.height;
      this.rightSide.height = this.bk.height - this.rightTop.height - this.rightBot.height;

      // align caption
      this.caption.hOffset = Math.round((this.win.width - this.caption.width) / 2);

      // align frame
      this.frame.width = this.win.width - 16 - this.scroller.width;
      this.frame.height = this.win.height - this.frame.vOffset - 11;

      // align scrollbar
      this.scroller.hOffset = this.frame.hOffset + this.frame.width;
      this.scroller.height = this.frame.height;

      // align buttons
      if (system.platform == "windows") {
        this.closeBtn.hOffset = this.bk.hOffset + this.bk.width + this.rightTop.width - 7;
      } else {
        this.closeBtn.hOffset = this.bk.hOffset + 3 + this.closeBtn.width;
      }
      this.closeBtn.vOffset = this.bk.vOffset + 7;
    } finally {
      resumeUpdates();
    }
  }

  this.clear = function() {
  }

  this.show = function() {
    if (!this.dynWin) this.createWin();
    this.dynWin.show();
  }

  this.doClose = function() {
    if (this.onClose) {
      this.onClose();
    }
  }

  this.hide = function() {
    if (this.win) {
      this.win.visible = false;
    }
  }

  this.close = function() {
    this.doClose();
    if (this.dynWin) {
      delete this.html;
      this.html = null;
      this.dynWin.destroy();
      delete this.dynWin;
      this.dynWin = null;
    }
  }
}

function showReadme() {
  if (readmeWin) return;
  readmeWin = new Readme();
  readmeWin.onClose = function() { delete readmeWin; readmeWin = null; }
  readmeWin.show();
}
