
var ssWin = null;

function SensorSelector() {
  this.dynWin = null;
  this.win = null;
  this.bk = null;
  this.descHeight = 0;
  this.selector = null;
  this.hoverSelector = null;
  this.target = null;
  this.targetIndex = -1;
  this.side = leftSide;
  this.place = tr("After");

  this.opacity = 160;
  this.onClose = function() {};
  this.name = "sensorSelectorObj";
  this.obj = eval(this.name + "=this");
  this.items = {};
  this.controls = [];
  this.controlsTop = 15;

  this.currentGroup = "";
  this.currentItem = -1;

  this.itemsShadow = new Shadow(mainWindow);
  this.itemsShadow.color = "#000000";
  this.itemsShadow.hOffset = 1;
  this.itemsShadow.vOffset = 1;

  this.createWin = function() {
    if (this.win) return;

    this.dynWin = new dynWindow("Scripts/Windows/selector.xml", this, false);
    this.win = this.dynWin.element;
    this.win.hOffset = Math.round((screen.availWidth - this.win.width) / 2);
    this.win.vOffset = Math.round((screen.availHeight - this.win.height) / 3);
    if (parseInt(preferences.position.value) == 2) {
      this.win.vOffset *= 2;
    }

    this.scroller.vOffset = 15 + this.caption.height + this.listLabel.height + 5;
    this.frame.vOffset = this.scroller.vOffset;

    this.comboBox.visible = (this.target != null);
    this.comboLabel1.visible = this.comboLabel2.visible = this.comboText.visible = this.comboBox.visible;

    if (this.target && this.target.getName) {
      this.comboLabel2.data = "'" + this.target.getName() + "'" + tr(" sensor");
    }

    this.resize();

    this.fillList();

    this.win.recalcShadow();
  }

  this.resize = function() {
    suppressUpdates();
    try {
      // resize
      this.bk.hOffset = this.leftTop.srcWidth;
      this.bk.vOffset = this.leftTop.srcHeight;
      this.bk.width = this.win.width - this.leftTop.srcWidth - this.rightTop.srcWidth;
      this.bk.height = this.win.height - this.leftTop.srcHeight - this.rightTop.srcHeight;

      this.leftTop.hOffset = 0;
      this.leftTop.vOffset = this.bk.vOffset;

      this.rightTop.hOffset = this.bk.hOffset + this.bk.width + this.rightTop.width;
      this.rightTop.vOffset = this.bk.vOffset;

      this.leftBot.hOffset = 0;
      this.leftBot.vOffset = this.bk.vOffset + this.bk.height;

      this.rightBot.hOffset = this.bk.hOffset + this.bk.width + this.rightBot.width;
      this.rightBot.vOffset = this.bk.vOffset + this.bk.height;

      this.leftSide.hOffset = 0;
      this.leftSide.vOffset = this.leftTop.vOffset + this.leftTop.height;
      this.leftSide.height = this.bk.height - this.leftTop.height - this.leftBot.height;

      this.rightSide.hOffset = this.bk.hOffset + this.bk.width;
      this.rightSide.vOffset = this.rightTop.vOffset + this.rightTop.height;
      this.rightSide.height = this.bk.height - this.rightTop.height - this.rightBot.height;

      // align caption
      this.caption.hOffset = Math.round((this.win.width - this.caption.width) / 2);

      // align frame
      this.frame.width = this.win.width - 11 - this.scroller.width;
      this.frame.height = this.win.height - this.frame.vOffset - 35 - this.listLabel.height - (this.comboBox.visible?25:0);

      // align scrollbar
      this.scroller.hOffset = this.frame.hOffset + this.frame.width;
      this.scroller.height = this.frame.height;

      // align selector
      this.hoverSelector.width = this.frame.width - 2;
      this.selector.width = this.frame.width - 2;

      // align buttons
      if (system.platform == "windows") {
        this.closeBtn.hOffset = this.bk.hOffset + this.bk.width + this.rightTop.width - 7;
      } else {
        this.closeBtn.hOffset = this.bk.hOffset + 3 + this.closeBtn.width;
      }
      this.closeBtn.vOffset = this.bk.vOffset + 7;

      this.comboLabel1.vOffset = this.comboLabel2.vOffset = this.frame.vOffset + this.frame.height + 23;

      this.comboBox.hOffset = this.comboLabel1.hOffset + this.comboLabel1.width + 5;
      this.comboBox.vOffset = this.comboLabel1.vOffset + 7;
      this.comboText.hOffset = this.comboBox.hOffset + 5;
      this.comboText.vOffset = this.comboLabel1.vOffset;

      this.comboLabel2.hOffset = this.comboBox.hOffset + this.comboBox.width + 5;
      this.comboLabel2.width = this.bk.width - this.comboLabel2.hOffset - 7;

      this.cancelBtn.hOffset = this.bk.hOffset + this.bk.width + this.rightTop.width - 5 - this.cancelBtn.width;
      this.cancelBtn.vOffset = this.win.height - this.cancelBtn.height + 7;

      this.addBtn.hOffset = this.cancelBtn.hOffset - 5 - this.addBtn.width;
      this.addBtn.vOffset = this.win.height - this.addBtn.height + 7;

      this.addBtnTxt.hOffset = this.addBtn.hOffset + Math.round((this.addBtn.width - this.addBtnTxt.width) / 2);
      this.cancelBtnTxt.hOffset = this.cancelBtn.hOffset + Math.round((this.cancelBtn.width - this.cancelBtnTxt.width) / 2);

    } finally {
      resumeUpdates();
    }
  }

  this.setPlace = function(value) {
    this.place = tr(value);
    this.comboText.data = tr(value);
  }

  this.clear = function() {
    for (var i = 0; i < this.controls.length; i++) {
      if (this.controls[i]) {
        this.controls[i].removeFromSuperview();
      }
    }
    this.controls = [];
  }

  this.hideSelectors = function() {
    this.hoverSelector.visible = false;
    this.selector.visible = false;
  }

  this.select = function(group, index, caller) {
    this.selector.vOffset = caller.vOffset - caller.height + 2;
    var h = caller.height + 3;
    if (this.items[group][index].description) {
      h += this.descHeight - 2;
    }
    this.selector.height = h;
    this.selector.visible = true;
    this.currentGroup = group;
    this.currentItem = index;
  }

  this.hover = function(group, index, caller) {
    this.hoverSelector.vOffset = caller.vOffset - caller.height + 2;
    var h = caller.height + 3;
    if (this.items[group][index].description) {
      h += this.descHeight - 2;
    }
    this.hoverSelector.height = h;
    this.hoverSelector.visible = true;
  }

  this.doubleClick = function(group, index, caller) {
    this.select(group, index, caller);
    this.add();
  }

  this.createGroup = function(groupName, items) {
    var gr = new Text(mainWindow);
    this.frame.addSubview(gr);
    gr.data = groupName;
    gr.hOffset = 9;
    gr.vOffset = this.controlsTop;
    gr.style.fontFamily = "\"Trebuchet MS, Arial, Helvetica\"";
    gr.style.fontSize = "13px";
    gr.style.fontWeight = "bold";
    gr.style.color = "#FFFFFF";
    gr.shadow = this.itemsShadow;
    gr.zOrder = 3;
    this.controls.push(gr);
    this.controlsTop += gr.height + 1;

    items.sort(compareSensorNames);
    for (var i = 0; i < items.length; i++) {
      var txt = new Text(mainWindow);
      this.frame.addSubview(txt);
      txt.data = items[i].name;
      txt.hOffset = 20;
      txt.vOffset = this.controlsTop;
      txt.width = this.frame.width - txt.hOffset - 2;
      txt.truncation = "end";
      txt.style.fontFamily = "\"Trebuchet MS, Arial, Helvetica\"";
      txt.style.fontSize = "12px";
      txt.style.color = "#FFFFFF";
      txt.tracking = "rectangle";
      eval(txt.name + "=txt");
      txt.onMouseEnter = this.hover.bind(this, [groupName, i, txt]);
      txt.onMouseUp = this.select.bind(this, [groupName, i, txt]);
      txt.onMultiClick = function(groupName, i, caller) {
        if (system.event.clickCount == 2) {
          this.doubleClick(groupName, i, caller);
        }
      }.bind(this, [groupName, i, txt]);
      txt.zOrder = 3;

      this.controls.push(txt);
      this.controlsTop += txt.height - 1;

      if (items[i].description) {
        var desc = new Text(mainWindow);
        this.frame.addSubview(desc);
        desc.data = items[i].description;
        desc.hOffset = 20;
        desc.vOffset = this.controlsTop;
        desc.width = this.frame.width - desc.hOffset - 2;
        desc.truncation = "end";
        desc.style.fontFamily = "\"Trebuchet MS, Arial, Helvetica\"";
        desc.style.fontSize = "12px";
        desc.style.color = "#DDDDDD";
        desc.tracking = "rectangle";
        desc.onMouseEnter = txt.onMouseEnter;
        desc.onMouseUp = txt.onMouseUp;
        desc.onMultiClick = txt.onMultiClick;
        desc.zOrder = 3;

        this.descHeight = desc.height;

        this.controls.push(desc);
        this.controlsTop += desc.height + 5;
      } else {
        this.controlsTop += 5;
      }
    }

    this.controlsTop += 12;
  }

  this.fillList = function() {
    this.hideSelectors();
    this.currentGroup = "";
    this.currentItem = -1;
    this.clear();
    this.items = {};
    var groups = [];
    for (var i = 0; i < dockFactory.items.length; i++) {
      if (!this.items[dockFactory.items[i].category]) {
        this.items[dockFactory.items[i].category] = [];
      }
      if (groups.indexOf(dockFactory.items[i].category) == -1) {
        groups.push(dockFactory.items[i].category);
      }
      this.items[dockFactory.items[i].category].push(dockFactory.items[i]);
    }
    groups.sort();

    this.controlsTop = 15;
    for (var i = 0; i < groups.length; i++) {
      this.createGroup(groups[i], this.items[groups[i]]);
    }

    var sep = new Text(mainWindow);
    this.frame.addSubview(sep);
    sep.data = " ";
    sep.hOffset = 10;
    sep.vOffset = this.controlsTop - 20;
    sep.size = 1;
    sep.height = 1;
    this.controls.push(sep);
  }

  this.add = function() {
    if (this.currentGroup == "") return;
    if (this.currentItem == -1) return;

    this.hide();

    if (this.target) {
      newSensorEx(this.side, this.items[this.currentGroup][this.currentItem].className, this.target, this.targetIndex, this.place.toLowerCase());
    } else {
      newSensorEx(this.side, this.items[this.currentGroup][this.currentItem].className, this.target, this.targetIndex);
    }

    this.close();
  }

  this.show = function() {
    if (!this.dynWin) this.createWin();
    this.dynWin.show();
  }

  this.doClose = function() {
    if (this.onClose) {
      this.onClose();
    }
  }

  this.hide = function() {
    if (this.win) {
      this.win.visible = false;
    }
  }

  this.close = function() {
    this.doClose();
    if (this.dynWin) {
      this.dynWin.destroy();
      delete this.dynWin;
      this.dynWin = null;
    }
  }
}

function newSensorWin(side) {
  if (ssWin) return;

  var target = null;
  var targetIndex = -1;
  if (arguments.length > 1) {
    target = arguments[1];
  }
  if (arguments.length > 2) {
    targetIndex = arguments[2];
  }
  
  ssWin = new SensorSelector();
  ssWin.onClose = function() { delete ssWin; ssWin = null; }
  ssWin.targetIndex = targetIndex;
  ssWin.target = target;
  ssWin.side = side;
  ssWin.show();
}
