
var DockBaseMeter = DockBaseTimer.extend({
  initialize: function() {
    this.parent();
    this.className = "DockBaseMeter";

    this.colorizeProp = new MultiColorProp("colorize", "Color:");
    this.props = [this.intervalProp, this.colorizeProp];
  },

  destroy: function() {
    if (this.parent()) {
      this.label = null;
      this.barBk = null;
      this.bak = null;
      this.value = null;
    }
  },

  updateProps: function(loaded) {
    this.parent(loaded);
    this.setColorize();
  },

  getName: function() {
    return "Base Meter";
  },

  meterName: function() {
    return "Base";
  },

  updatePrefs: function() {
    this.parent();
    if (this.label) { $$font(this.label, preferences.sensorsFont.value, preferences.sensorsFontStyle.value); }
    if (this.value) { $$font(this.value, preferences.sensorsFont.value, preferences.sensorsFontStyle.value); }
    this.updateValue();
    dockObj.align();
  },

  updateColor: function() {
    this.parent();
    if (this.label) { this.label.style.color = this.color; }
    if (this.value) { this.value.style.color = this.color; }
    this.setColorize();
  },

  createControls: function() {
    if (this.parent()) {
      this.label = new Text(mainWindow);
      this.frame.addSubview(this.label);
      this.label.hOffset = 8;
      this.label.vOffset = 11;
      this.label.data = this.meterName();
      this.label.style.fontFamily = "Arial, Helvetica";
      this.label.style.fontSize = "9px";
      this.label.style.fontWeight = "bold";
      this.label.style.color = this.color;

      this.barBk = new Image(mainWindow);
      this.frame.addSubview(this.barBk);
      this.barBk.hOffset = 0;
      this.barBk.vOffset = 3;
      this.barBk.width = 4;
      this.barBk.height = 19;
      this.barBk.src = "Resources/Sensors/Fill.png";
      this.barBk.opacity = 80;

      this.bar = new Image(mainWindow);
      this.frame.addSubview(this.bar);
      this.bar.hOffset = 0;
      this.bar.vOffset = 3;
      this.bar.width = 4;
      this.bar.height = 19;
      this.bar.src = "Resources/Sensors/Fill.png";

      this.value = new Text(mainWindow);
      this.frame.addSubview(this.value);
      this.value.hOffset = 32;
      this.value.vOffset = 21;
      this.value.data = "0%";
      this.value.style.fontFamily = "Arial, Helvetica";
      this.value.style.fontSize = "9px";
      this.value.style.fontWeight = "bold";
      this.value.style.color = this.color;
      this.value.hAlign = "right";

      this.setColorize();
      this.updateValue();
    }
    return (this.frame != null);
  },
  
  getValue: function() {
    return 0;
  },

  updateValue: function() {
    if (!this.bar) return;

    value = this.getValue();
    this.value.data = value + "%";
    value /= 100.0;

    this.bar.height = Math.round(value * this.barBk.height);
    this.bar.vOffset = this.barBk.vOffset + this.barBk.height - this.bar.height;
    if (this.colorizeProp.isDynamic) {
      this.bar.colorize = this.colorizeProp.colorize(value);
    }
  },

  setColorize: function() {
    if (this.bar) {
      this.barBk.colorize = this.color;
      var colorize = this.colorizeProp.colorize(this.getValue() / 100.0);
      if (colorize) {
        this.bar.colorize = colorize;
        this.bar.opacity = 255;
      } else {
        this.bar.colorize = this.color;
        this.bar.opacity = 150;
      }
    }
  }
});
