
var DockBaseSoloGraph = DockBaseGraph.extend({
  initialize: function() {
    this.parent();
    this.className = "DockBaseSoloGraph";

    this.graphColorizeProp = new MultiColorProp("graph-color", "Graph color:", 
                                                "#00FF00", coActive);
    this.props.push(this.graphColorizeProp);
    this.graphOpacityProp = new OpacityProp("graph-opacity", "Graph:", 140, 50);
    this.props.push(this.graphOpacityProp);
    
    this.graph = [];
    this.index = 0;
  },

  clear: function() {
    this.graph = [];
  },

  updateProps: function(loaded) {
    this.parent(loaded);
    for (var i = 0; i < this.graph.length; i++) {
      var value = this.graph[i].height / 21;
      this.graph[i].colorize = this.graphColorizeProp.colorize(value);
      this.graph[i].opacity = this.graphOpacityProp.value;
    }
  },

  createGraphControls: function() {
    for (var i = 0; i < this.widthProp.value; i++) {
      var g = new Image(mainWindow);
      this.frame.addSubview(g);
      g.src = "Resources/Sensors/pixel.png";
      g.hOffset = i;
      g.vOffset = 23;
      g.vAlign = "bottom";
      g.width = 1;
      g.height = 0;
      g.opacity = this.graphOpacityProp.value;
      g.zOrder = 3;

      this.graph.push(g);
    }
  },

  updateValue: function() {
    if (this.value) {
      this.value.data = this.getValueText();
    }

    var value = this.getValue() * 0.01;
    this.graph[this.index].height = Math.round(value * 21);
    this.graph[this.index].colorize = this.graphColorizeProp.colorize(value);

    var last = this.widthProp.value - 1;
    if (--this.index < 0) this.index = last;

    var x = this.index;
    for (i = 0; i <= last; i++) {
      this.graph[i].hOffset = x;
      if (--x < 0) x = last;
    }
  },

  getValue: function() {
    return 0;
  }

});
