
var DockBaseText = DockText.extend({
  initialize: function(interval) {
    this.parent();
    this.className = "DockBaseText";
    this.timer = null;
    this.intervalProp = new IntervalProp(interval, this.minInterval());
    
    this.props = [this.intervalProp].concat(this.props);
  },

  destroy: function() {
    if (this.parent()) {
      delete this.timer;
      this.timer = null;
    }
  },

  minInterval: function() {
    return 30.0;
  },

  updateProps: function(loaded) {
    this.parent(loaded);
    this.setInterval();
  },

  createControls: function() {
    if (this.parent()) {
      this.timer = new Timer();
      this.timer.interval = this.intervalProp.value;
      this.timer.onTimerFired = this.updateValue.bind(this);
      this.timer.ticking = true;
    }
    return (this.frame != null);
  },

  setInterval: function() {
    if (this.timer) {
      this.timer.ticking = false;
      this.timer.interval = this.intervalProp.value;
      this.timer.ticking = true;
    }
  }
});
