
var DockBaseTimer = DockBase.extend({
  initialize: function(interval, timerFunction) {
    this.parent();
    this.className = "DockBaseTimer";
    this.timer = null;
    //this.timerFunction = timerFunction ? timerFunction : ".updateValue();";
    this.timerFunction = timerFunction ? timerFunction : this.updateValue;
    if (this.minInterval() < 60.0) {
      this.intervalProp = new IntervalProp(interval ? interval 
                                                    : this.minInterval(), 
                                           this.minInterval());
    } else {
      this.intervalProp = new Interval2Prop(interval ? interval 
                                                     : this.minInterval(), 
                                            this.minInterval());
    }
  },

  destroy: function() {
    if (this.parent()) {
      delete this.timer;
      this.timer = null;
    }
  },

  minInterval: function() {
    return 10.0;
  },

  updateProps: function(loaded) {
    this.setInterval();
  },

  getName: function() {
    return "Base Timer";
  },

  meterName: function() {
    return "Timer";
  },

  createControls: function() {
    if (this.parent()) {
      this.timer = new Timer(mainWindow);
      this.timer.interval = this.intervalProp.value;
      //this.timer.onTimerFired = this.obj.name + this.timerFunction;
      //this.timer.onTimerFired = this.timerFunction.bind(this);
      var t = this;
      this.timer.onTimerFired = function() { t.timerFunction.call(t); }
      this.timer.ticking = true;
    }
    return (this.frame != null);
  },
  
  setInterval: function() {
    if (this.timer) {
      this.timer.ticking = false;
      this.timer.interval = this.intervalProp.value;
      this.timer.ticking = true;
    }
  }
});
