
include("Sensors/CPUHint.js");

var DockCPUMeter = DockBaseMeter.extend({
  initialize: function(disk) {
    this.parent();
    this.className = "DockCPUMeter";
  },

  minInterval: function() {
    return 1.0;
  },

  getName: function() {
    return tr("CPU Meter");
  },

  meterName: function() {
    return tr("CPU");
  },

  getHint: function() {
    return getCPUHint();
  },

  doClick: function() {
    this.parent();
    if (system.platform == "windows") {
      runCommandInBg("%SystemRoot%/system32/taskmgr.exe", "taskManagerRun");
    }
    if (system.platform == "macintosh") {
      filesystem.open("/Applications/Utilities/Activity Monitor.app");
    }
  },

  getValue: function() {
    return system.cpu.activity;
  }

});

dockFactory.register({name: tr("CPU Meter"),
                      className: "DockCPUMeter",
                      classDef: DockCPUMeter,
                      category: tr("System"),
                      description: tr("Show CPU usage")
                      });
