
var DateHint = Hint.extend({
  
  lineSpace: 2,

  initialize: function() {
    this.parent();
    this.showCalendar = false;
    this.weekStart = 1;  /* 0 = sunday, 1 = monday */
    this.day = new Array(7);
    for (var i = 0; i < 7; i++) {
      this.day[i] = new Array(7);
    }
    this.today = null;
    this.offset = {x: 6, y: (preferences.position.value == 1 ? 5 : 0) + 12};
    this.calendarHeight = 0;
    this.size = {width: 0, height: 0};
    this.buildDate = 0;
  },

  setShowCalendar: function(value, weekstart) {
    this.showCalendar = value;
    this.weekStart = weekstart;
    var now = new Date();
    if (this.showCalendar && (this.buildDate != now.getYMD())) {
      this.buildCalendar();
    }
  },

  createChilds: function() {
    this.parent();

    this.today = new Image(mainWindow);
    this.today.window = this.win;
    this.today.src = "Resources/Hint/Fill.png";
    this.today.colorize = "#000000";
    this.today.opacity = 220;
    this.today.zOrder = 2;
    this.today.visible = false;

    for (var n = 0; n < 7; n++) {
      for (var i = 0; i < 7; i++) {
        var day = new Text(mainWindow);
        day.window = this.win;
        day.style.color = preferences.popupTextColor.value;
        if (this.isWeekEnd(i)) {
          day.style.color = preferences.popupStrongTextColor.value;
        }
        //day.style.fontFamily = $font((preferences.popupTextFont.value == '')?'Arial':preferences.popupTextFont.value);
        day.style.fontSize = parseInt(preferences.popupTextSize.value) + "px";
        //day.style.fontWeight = "bold";
        $$font(day, (preferences.popupTextFont.value == '')?'Arial':preferences.popupTextFont.value, preferences.popupTextFontStyle.value);
        day.hAlign = (n == 0) ? "center" : "right";
        day.hOffset = 6;
        day.vOffset = 6;
        day.zOrder = 3;
        //day.opacity = parseInt(preferences.popupOpacity.value);
        day.opacity = (n > 0)?200:255;
        day.visible = false;
        this.day[n][i] = day;
      }           
    }

    if (this.showCalendar) {
      this.buildCalendar();
    }
  },

  isWeekEnd: function(i) {
    return ((i + 6 + this.weekStart) % 7 >= 5);
  },
  
  updatePrefs: function() {
    this.parent();
    try {
      var now = new Date();
      var today = now.getDate();
      for (var n = 0; n < 7; n++) {
        for (var i = 0; i < 7; i++) {
          try {
            //this.day[n][i].style.fontFamily = $font((preferences.popupTextFont.value == '')?'Arial':preferences.popupTextFont.value);
            this.day[n][i].style.fontSize = parseInt(preferences.popupTextSize.value) + "px";
            //this.day[n][i].style.fontWeight = "bold";
            $$font(this.day[n][i], (preferences.popupTextFont.value == '')?'Arial':preferences.popupTextFont.value, preferences.popupTextFontStyle.value);
          } catch(e) {}
        }
      }

      // Set the position dependend offset and update all elements
      this.offset.y = (preferences.position.value == 1 ? 5 : 0) + 12;
    } catch (e) { }
    this.buildDate = 0;
  },

  buildCalendar: function() {
    if (!this.day[0][0]) return;
    
    var now = new Date();
    var today = now.getDate();
    var days = now.getCalendar2(this.weekStart);
    this.buildDate = now.getYMD();

    var colW = 0;
    for (var i = 0; i < 7; i++) {
      this.day[0][i].data = Date.weekShort[(i + this.weekStart) % 7].trim();
      if (this.day[0][i].width > colW) {
        colW = this.day[0][i].width + 5;
      }
    }
    if (colW < 29) colW = 29;

    for (var n = 0; n < days.length; n++) {
      for (var i = 0; i < 7; i++) {
        var day = days[n][i];
        this.day[n + 1][i].data = day ? day : "";
      }
    }

    var dayW = 0;
    var lineH = this.day[0][0].height;
    for (var n = 0; n < days.length + 1; n++) {
      for (var i = 0; i < 7; i++) {
        if ((n > 0) && (this.day[n][i].width > dayW)) {
          dayW = this.day[n][i].width;
        }
        if (this.day[n][i].height > lineH) {
          lineH = this.day[n][i].height;
        }
      }
    }
    lineH += this.lineSpace;

    for (var n = 0; n < days.length + 1; n++) {
      for (var i = 0; i < 7; i++) {
        var day = this.day[n][i];
        day.style.color = preferences.popupTextColor.value;
        if (day.data == today) {
          day.style.color = preferences.popupColor.value;
        } else if (this.isWeekEnd(i)) {
          day.style.color = preferences.popupStrongTextColor.value;
        }
        if (n == 0) {
          day.hOffset = 6 + colW * (i + 0.5) + 8;
        } else {
          day.hOffset = 6 + colW * (i + 1);
        }
        day.vOffset = this.offset.y + 6 + lineH * n;
        
        if (day.data == today) {
          day.style.color = preferences.popupColor.value;
          
          this.today.colorize = this.isWeekEnd(i) ? preferences.popupStrongTextColor.value 
                                                  : preferences.popupTextColor.value;
          var diff = colW - dayW;
          this.today.hOffset = 6 + colW * (i + 1) - dayW - (diff + 3) / 4;
          this.today.vOffset = this.offset.y + 6 + lineH * n - 0.75 * (lineH - this.lineSpace);
          this.today.width = dayW + diff / 2;
          this.today.height = lineH - this.lineSpace;
        }
      }
    }

    this.size.width = colW * 7 + 4;
    this.size.height = lineH * (days.length + 2) + 12;
    this.calendarHeight = lineH * days.length + 4;

    for (var n = 0; n < days.length + 1; n++) {
      for (var i = 0; i < 7; i++) {
        this.day[n][i].visible = true;
      }
    }
    if (days.length == 4) {
      for (var i = 0; i < 7; i++) {
        this.day[5][i].visible = false;
      }
    }
    this.today.visible = true;
  },

  doResize: function() {
    this.parent();

    if (this.showCalendar) {
      this.bk.width = this.size.width;
      this.bk.height = this.size.height;
      this.hintText.vOffset = this.offset.y + 9 + this.calendarHeight;
      try {
        for (var n = 0; n < days.length + 1; n++) {
          for (var i = 0; i < 7; i++) {
            this.day[n][i].visible = true;
          }
        }
        this.today.visible = true;
      } catch(e) {}
    } else {
      try {
        for (var n = 0; n < 7; n++) {
          for (var i = 0; i < 7; i++) {
            this.day[n][i].visible = false;
          }
        }
        this.today.visible = false;
      } catch(e) {}
      
      this.hintText.vOffset = this.offset.y - 6;
      this.bk.width = this.hintText.width + 12;
    }
  },

  show: function(x, y) {
    var now = new Date();
    if (this.showCalendar && (this.buildDate != now.getYMD())) {
      this.buildCalendar();
    }
    if (arguments.length < 3) {
      this.parent(x, y);
    } else {
      this.parent(x, y, arguments[2]);
    }
  }
});

