
var DockDisk = DockBaseShortcut.extend({
  initialize: function() {
    this.parent();
    this.className = "DockDisk";
    this.ejectable = null;
    
    this.diskProp = new DiskProp("", false);
    
    this.props.unshift(this.diskProp);
  },

  updateProps: function(loaded) {
    if (this.diskProp.value != "") {
      this.setDisk(this.diskProp.value);
    }
    this.parent();
  },

  getName: function() {
    return tr("Disk");
  },

  isEjectable: function() {
    var vols = filesystem.volumes;
    for (var v in vols) {
      if (vols[v].path != this.diskProp.value) continue;
      return (vols[v].freeBytes == 0);
    }
    return false;
  },

  sensorMenuItems: function(items) {
    this.parent();

    if (this.ejectable) {
      var item = new MenuItem();
      item.title = (system.platform == "windows")?"-":"(-";
      items.push(item);

      var item = new MenuItem();
      item.title = tr("Eject");
      item.onSelect = this.eject.bind(this);
      items.push(item);
    }
  },

  eject: function() {
    if (system.platform == "windows") {
      shellApp = COM.createObject("Shell.Application");
      shellApp.NameSpace(17).ParseName(this.diskProp.value).InvokeVerb("e&ject"); // spelling of "eject" ?
    } else {
      //alert("Not yet available on Macintosh.");
      //appleScript('tell application "Finder" to eject "' + this.diskProp.value + '"');
      filesystem.moveToTrash(this.diskProp.value);
    }
  },

  getTarget: function() {
    return this.diskProp.value;
  },

  setDisk: function(value) {
    this.diskProp.value = value;
    this.ejectable = this.isEjectable();
    this.setImage();
  },

  doSetImage: function(value) {
    if (this.imageProp.value == "") {
      this.image.src = this.diskProp.value;
      this.image.useFileIcon = true;
    } else {
      this.image.src = this.imageProp.value;
      this.image.useFileIcon = false;
    }
  },

  doGetTitle: function() {
    return filesystem.getDisplayName(this.diskProp.value);
  },

  doClick: function() {
    this.parent();
    filesystem.open(this.diskProp.value);
  }
});

dockFactory.register({name: tr("Disk"),
                      className: "DockDisk",
                      classDef: DockDisk,
                      category: tr("System"),
                      description: tr("Open, eject, etc. disk drive")
                      });
