
include("Sensors/GMailHint.js");

var DockGMailForDomains = DockGMail.extend({
  initialize: function() {
    this.parent(tr("GMail for Domains"));
    this.className = "DockGMailForDomains";

    this.props.remove(this.autoLoginProp);

    this.titleProp.value = tr("GMail for Domains");
    this.domainProp = new TextProp("domain", tr("Domain:"), "", "");

    this.props.insert(this.props.indexOf(this.passwordProp) + 1, this.domainProp);
    this.usernameProp.description = tr("Please enter username without your domain (@yourdomain.com).");
  },

  getName: function() {
    return tr("GMail for Domains Checker");
  },

  doOpenClient: function() {
    this.openURL("http://mail.google.com/a/" + this.domainProp.value + "/");
  },

  getUrl: function() {
    return "https://mail.google.com/a/" + this.domainProp.value + "/feed/atom";
  },

  getUserName: function() {
    return this.usernameProp.value + "@" + this.domainProp.value;
  },

  genCacheName: function() {
    return "gmail-" + this.usernameProp.value + "@" + this.domainProp.value + ".xml";
  }
});

dockFactory.register({name: tr("GMail for Domains Checker"),
                      className: "DockGMailForDomains",
                      classDef: DockGMailForDomains,
                      category: tr("Internet"),
                      description: tr("Check mail on GMail for Domains")
                      });
