
var DockImage = DockBase.extend({
  initialize: function() {
    this.parent();
    this.className = "DockImage";
    this.image = null;
    
    this.imageProp = new FileProp("image", "Image:", 
                                  "Image to display, maximum height 24 pix.\nLeave blank for Informer's logo.",
                                  [".jpg", ".png", ".gif", ".bmp", ".ico"]);
    this.colorizeProp = new ColorizeProp("colorize", "Color:");
    this.opacityProp = new OpacityProp("opacity", "Opacity:", 255, 50);
    this.textProp = new TextProp("text", "Text in popup:", "", 
                                 "Text to display in popup.");
    
    this.props = [this.imageProp, this.colorizeProp, this.opacityProp, 
                  this.textProp];
    
  },

  destroy: function() {
    if (this.parent()) {
      this.image = null;
    }
  },

  updateProps: function(loaded) {
    if (this.image) {
      this.image.src = (this.imageProp.value != "") 
                     ? this.imageProp.value : "Resources/Sensors/Logo.png";
      this.image.vOffset = Math.round((25 - this.image.srcHeight) / 2);
      this.image.width = this.image.srcWidth;
      this.image.opacity = this.opacityProp.value;
      this.image.colorize = this.colorizeProp.colorize();
      dockObj.align();
    }
  },

  getName: function() {
    return tr("Image");
  },

  createControls: function() {
    if (this.parent()) {
      this.image = new Image(mainWindow);
      this.frame.addSubview(this.image);
      this.image.missingSrc = "Resources/Sensors/Logo.png";
      this.image.hOffset = 0;
      this.updateProps();
    }
    return (this.frame != null);
  },

  getHint: function() {
    var s = this.textProp.value;
    if (s) s = s.replace("%v", widget.version);
    return s;
  }
});

dockFactory.register({name: tr("Image"),
                      className: "DockImage",
                      classDef: DockImage,
                      category: tr("General"),
                      description: tr("Image (icon)")
                      });
