
var MailHint = Hint.extend({
  initialize: function(owner) {
    this.owner = owner;
    this.xml = "";
    this.datesText = "";
    this.dates = null;
    this.from = null;
    this.fromText = "";
    this.newHeaders = null;
    this.newHeadersText = "";
    this.limited = false;
    this.rowLimit = 15;
    this.widthLimit = 40;
    this.clientMsg = tr("Click to open Mail client");
    this.path = "/inbox/headers/entry";
    this.parent();
  },

  createChilds: function() {
    this.parent();
    this.dates = new TextArea(mainWindow);
    this.dates.window = this.win;
    this.dates.editable = false;
    this.dates.scrollbar = false;
    this.dates.style.color = "#FFFFFF";
    this.dates.style.fontFamily = "Arial, Helvetica";
    this.dates.style.fontSize = "12px";
    this.dates.style.fontWeight = "normal";
    this.dates.hOffset = 6;
    this.dates.vOffset = 6;
    this.dates.data = this.datesText;
    this.dates.zOrder = 2;
    this.dates.opacity = 180;

    this.from = new TextArea(mainWindow);
    this.from.window = this.win;
    this.from.editable = false;
    this.from.scrollbar = false;
    this.from.style.color = "#FFFFFF";
    this.from.style.fontFamily = "Arial, Helvetica";
    this.from.style.fontSize = "12px";
    this.from.style.fontWeight = "normal";
    this.from.hOffset = 6;
    this.from.vOffset = 6;
    this.from.data = this.fromText;
    this.from.zOrder = 2;
    this.from.opacity = 180;

    this.newHeaders = new TextArea(mainWindow);
    this.newHeaders.window = this.win;
    this.newHeaders.editable = false;
    this.newHeaders.scrollbar = false;
    this.newHeaders.style.color = preferences.popupStrongTextColor.value;
    this.newHeaders.style.fontFamily = "Arial, Helvetica";
    this.newHeaders.style.fontSize = "12px";
    this.newHeaders.style.fontWeight = "normal";
    this.newHeaders.hOffset = this.hintText.hOffset;
    this.newHeaders.vOffset = 6;
    this.newHeaders.data = this.newHeadersText;
    this.newHeaders.zOrder = 3;
  },

  updatePrefs: function() {
    this.parent();
    if (this.dates) {
      var dates = this.dates.data;
      try {
        this.dates.data = "";

        //this.dates.style.fontFamily = $font(preferences.popupTextFont.value);
        $$font(this.dates, preferences.popupTextFont.value, preferences.popupTextFontStyle.value);
        this.dates.style.fontSize = parseInt(preferences.popupTextSize.value) + "px";
        this.dates.style.color = preferences.popupTextColor.value;
      } finally {
        this.dates.data = dates;
        //this.dates.style.fontWeight = "bold";
      }
    }

    if (this.from) {
      var dates = this.from.data;
      try {
        this.from.data = "";

        //this.from.style.fontFamily = $font(preferences.popupTextFont.value);
        $$font(this.from, preferences.popupTextFont.value, preferences.popupTextFontStyle.value);
        this.from.style.fontSize = parseInt(preferences.popupTextSize.value) + "px";
        this.from.style.color = preferences.popupTextColor.value;
      } finally {
        this.from.data = dates;
        //this.from.style.fontWeight = "bold";
      }
    }

    if (this.newHeaders) {
      var headers = this.newHeaders.data;
      try {
        this.newHeaders.data = "";

        //this.newHeaders.style.fontFamily = $font(preferences.popupTextFont.value);
        $$font(this.newHeaders, preferences.popupTextFont.value, preferences.popupTextFontStyle.value);
        this.newHeaders.style.fontSize = parseInt(preferences.popupTextSize.value) + "px";
        this.newHeaders.style.color = preferences.popupStrongTextColor.value;
      } finally {
        this.newHeaders.data = headers;
        //this.newHeaders.style.fontWeight = "bold";
      }
    }
  },

  doResize: function() {
    this.parent();

    if ((this.hintText.data == "") || (this.hintText.data == "\n")) {
      this.bk.height -= this.hintText.height;
    }

    this.recalcTextArea(this.newHeaders);
    this.recalcTextArea(this.from);
    this.recalcTextArea(this.dates);

    this.hintText.vOffset = this.newHeaders.vOffset + ((this.newHeaders.data != "")?this.newHeaders.height:0);

    var w = this.from.hOffset + this.from.width;
    if (this.from.data == "") { w = 0; }
    if (w > 0) {
      this.hintText.hOffset = w;
      this.bk.hOffset -= this.from.width;
      this.bk.width += this.dates.width - 3 + this.from.width;
      if (this.newHeaders.data != "") {
        this.bk.height += this.newHeaders.height;
      }
      if (!this.limited && dockObj.locked) {
        this.bk.height += 2;
      }
      if (this.newHeaders.width > this.hintText.width) {
        this.bk.width += (this.newHeaders.width - this.hintText.width);
      }
    } else {
      this.hintText.hOffset = 6;
      this.bk.hOffset = 6;
      this.bk.width = this.hintText.width + 12;
    }
    this.dates.hOffset = this.bk.width - this.dates.width + 4;
    this.dates.vOffset = this.newHeaders.vOffset;
    this.from.vOffset = this.newHeaders.vOffset;
    this.newHeaders.hOffset = this.hintText.hOffset;
  },

  setDates: function(dates) {
    this.datesText = dates;
    if (this.dates) {
      this.dates.data = dates;
    }
  },

  setFrom: function(value) {
    this.fromText = value;
    if (this.from) {
      this.from.data = value;
    }
  },

  setNewText: function(value) {
    this.newHeadersText = value;
    if (this.newHeaders) {
      this.newHeaders.data = value;
      this.hintText.vOffset = this.newHeaders.vOffset + ((this.newHeaders.data != "")?this.newHeaders.height:0);
    }
  },

  setText: function(value) {
    this.parent(value);
    if (this.hintText && this.newHeaders) {
      this.hintText.vOffset = this.newHeaders.vOffset + ((this.newHeaders.data != "")?this.newHeaders.height:0);
    }
  },

  setOptions: function(rowLimit, widthLimit) {
    this.rowLimit = rowLimit;
    this.widthLimit = widthLimit;
  },

  render: function() {
    if (this.owner.headers.length > 0) {
      try {
        var n = s = d = f = tmp = "";
        var count = newCount = 0;
        var headers = [];
        for (var i = 0; i < this.owner.headers.length; i++) {
          var title = this.owner.headers[i].subject;
          if ((this.widthLimit != -1) && (title.length >= this.widthLimit)) {
            title = title.substr(0, this.widthLimit) + "...";
          }
          var author = this.owner.headers[i].from.name;
          if (author == '') {
            author = this.owner.headers[i].from.addr;
          }
          if (author.length > 15) {
            author = author.substr(0, 15) + "...";
          }
          headers.push({title: title, date: this.owner.headers[i].date.toString(tr("%b %d %H:%M")), author: author, isNew: this.owner.headers[i].isNew});
        }
        for (var i = headers.length - 1; i >= 0; i--) {
          if ((this.rowLimit != -1) && (++count > this.rowLimit)) {
            s += "...\n";
            this.limited = true;
            break;
          }
          d += headers[i].date + "\n";
          f += headers[i].author + "\n";
          if (headers[i].isNew) {
            n += headers[i].title + "\n";
            newCount++;
          } else {
            s += headers[i].title + "\n";
          }
        }

        if (newCount <= 0) {
          n = "";
        }
        if ((n == "") && (s == "")) {
          s = tr("no e-mails") + "\n";
        }
        if (!dockObj.locked) {
          s += "\n" + this.clientMsg + "\n";
        }
        this.setFrom(f);
        this.setDates(d);
        this.setNewText(n);
        this.setText(s);
      } catch(e) {
        this.setFrom("");
        this.setDates("");
        this.setNewText("");
        this.setText(tr("Format error (" + e + ")"));
      }
    } else {
      this.setFrom("");
      this.setDates("");
      this.setNewText("");
      this.setText(tr("no e-mails"));
    }
  },

  setErrorText: function(_text) {
    var text = _text;
    if (text) {
      try {
        text = text.replace(/(\n\r)*$/g, "");
      } catch(e) {}
    }
    this.xml = "";
    this.setFrom("");
    this.setDates("");
    this.setNewText("");
    text = tr(text.trim());
    if (text.toLowerCase().indexOf("error") == -1) {
      text = tr("Error:") + " " + text;
    }
    this.setText(text);
  }
});
