
include("Sensors/MemHint.js");

/* ------------------------------------------------------------------------ */

// Original sensor by Alexander Gross

var DockMemGraph = DockBaseMemGraph.extend(
{
  initialize: function()
  {
    this.parent();
    this.className = "DockMemGraph";
  },

  getName: function()
  {
    return tr("Memory Graph");
  },

  graphName: function()
  {
    return tr("RAM");
  },

  getValue: function()
  {
    return system.memory.load;
  },

  getValueText: function()
  {
    if (this.showModeProp.value == mgmValue) {
      return trBytesToUI(system.memory.totalPhysical - system.memory.availPhysical);
    }
    return system.memory.load + "%";
  },

  getTitle: function()
  {
    return tr("RAM usage history");
  },

  getHint: function()
  {
    return getMemHint();
  }
});

dockFactory.register({name: tr("Memory Graph"),
                      className: "DockMemGraph",
                      classDef: DockMemGraph,
                      category: tr("System"),
                      description: tr("Show used physical memory history")
                      });
