
var RSSHint = Hint.extend({
  initialize: function(owner) {
    this.owner = owner;
    this.xml = "";
    this.datesText = "";
    this.dates = null;
    this.parent();
    this.widthLimit = 40;
    this.limited = false;
  },

  createChilds: function() {
    this.parent();
    this.dates = new TextArea(mainWindow);
    this.dates.window = this.win;
    this.dates.editable = false;
    this.dates.scrollbar = false;
    this.dates.style.color = "#FFFFFF";
    this.dates.style.fontFamily = "Arial, Helvetica";
    this.dates.style.fontSize = "12px";
    this.dates.style.fontWeight = "normal";
    this.dates.hOffset = 6;
    this.dates.vOffset = 6;
    this.dates.data = this.datesText;
    this.dates.zOrder = 2;
    this.dates.opacity = 180;

    this.newHeaders = new TextArea(mainWindow);
    this.newHeaders.window = this.win;
    this.newHeaders.editable = false;
    this.newHeaders.scrollbar = false;
    this.newHeaders.style.color = preferences.popupStrongTextColor.value;
    this.newHeaders.style.fontFamily = "Arial, Helvetica";
    this.newHeaders.style.fontSize = "12px";
    this.newHeaders.style.fontWeight = "normal";
    this.newHeaders.hOffset = this.hintText.hOffset;
    this.newHeaders.vOffset = 6;
    this.newHeaders.data = this.newHeadersText;
    this.newHeaders.zOrder = 3;
  },

  updatePrefs: function() {
    this.parent();
    if (this.dates) {
      var dates = this.dates.data;
      try {
        this.dates.data = "";

        //this.dates.style.fontFamily = $font(preferences.popupTextFont.value);
        $$font(this.dates, preferences.popupTextFont.value, preferences.popupTextFontStyle.value);
        this.dates.style.fontSize = parseInt(preferences.popupTextSize.value) + "px";
        this.dates.style.color = preferences.popupTextColor.value;
      } finally {
        this.dates.data = dates;
        //this.dates.style.fontWeight = "bold";
      }
    }

    if (this.newHeaders) {
      var headers = this.newHeaders.data;
      try {
        this.newHeaders.data = "";

        //this.newHeaders.style.fontFamily = $font(preferences.popupTextFont.value);
        $$font(this.newHeaders, preferences.popupTextFont.value, preferences.popupTextFontStyle.value);
        this.newHeaders.style.fontSize = parseInt(preferences.popupTextSize.value) + "px";
        this.newHeaders.style.color = preferences.popupStrongTextColor.value;
      } finally {
        this.newHeaders.data = headers;
        //this.newHeaders.style.fontWeight = "bold";
      }
    }
  },

  doResize: function() {
    this.parent();

    if ((this.hintText.data == "") || 
        ((this.hintText.data == "\n") && (this.newHeaders.data == "\n"))) {
      this.bk.height -= this.hintText.height;
    }
    if (!this.limited && dockObj.locked) {
      this.bk.height += 2;
    }

    this.recalcTextArea(this.newHeaders);
    this.recalcTextArea(this.dates);

    this.hintText.hOffset = 6;
    this.bk.hOffset = 6;
    this.bk.width = this.hintText.width + this.dates.width + 12;
    if (this.newHeaders.width > this.hintText.width) {
      this.bk.width += (this.newHeaders.width - this.hintText.width);
    }

    this.newHeaders.hOffset = this.hintText.hOffset;
    this.newHeaders.vOffset = this.hintText.vOffset;
    this.dates.hOffset = this.bk.width - this.dates.width + 4;
    this.dates.vOffset = this.newHeaders.vOffset;
  },

  setDates: function(dates) {
    this.datesText = dates;
    if (this.dates) {
      this.dates.data = dates;
    }
  },

  setNewText: function(value) {
    this.newHeadersText = value;
    if (this.newHeaders) {
      this.newHeaders.data = value;
    }
  },

  setOptions: function(widthLimit) {
    this.widthLimit = widthLimit;
  },

  render: function() {
    if (this.owner.total > 0) {
      try {
        var n = s = d = "";
        var count = this.owner.headers.length;
        for (var i = 0; i < count; i++) {
          var title = this.owner.headers[i].title;
          if ((this.widthLimit != -1) && (title.length >= this.widthLimit)) {
            title = title.substr(0, this.widthLimit) + "...";
          }
          d += this.owner.headers[i].date + "\n";
          if (this.owner.headers[i].isNew) {
            n += title + "\n";
            s += "\n";
          } else {
            n += "\n";
            s += title + "\n";
          }
        }
        this.limited = (count < this.owner.total);
        if (this.limited) {
          s += "...\n";
        }
        if (!dockObj.locked) {
          s += "\n" + tr("Click to open RSS Reader") + "\n";
        }
        this.setDates(d);
        this.setNewText(n);
        this.setText(s);
      } catch(e) {
        this.setDates("");
        this.setNewText("");
        this.setText(tr("RSS format error"));
      }
    } else {
      this.setDates("");
      this.setNewText("");
      this.setText(tr("no news"));
    }
  },

  setErrorText: function(text) {
    this.xml = "";
    this.setDates("");
    this.setNewText("");
    this.setText(tr("Error:") + " " + text);
  }
});

