
/* ------------------------------------------------------------------------ */

// Original sensor by Alexander Gross

var DockSwapGraph = DockBaseMemGraph.extend(
{
  initialize: function()
  {
    this.parent();
    this.className = "DockSwapGraph";
    this.swapFileInfo = new SwapFileInfo();
  },

  getName: function()
  {
    return tr("Swap Graph");
  },

  graphName: function()
  {
    return tr("Swap");
  },

  getValue: function()
  {
    this.swapFileInfo.getData();
    return this.swapFileInfo.load;
  },

  getValueText: function()
  {
    if (this.showModeProp.value == mgmValue) {
      return trBytesToUI(this.swapFileInfo.usedVirtual);
    }
    return this.swapFileInfo.load + "%";
  },

  getTitle: function()
  {
    return tr("Swap-file usage history");
  },

  getHint: function()
  {
    return this.swapFileInfo.getHint();
  }
});

dockFactory.register({name: tr("Swap Graph"),
                      className: "DockSwapGraph",
                      classDef: DockSwapGraph,
                      category: tr("System"),
                      description: tr("Show used swap-file history")
                      });
