
var DockSwapMeter = DockBaseMeter.extend({
  initialize: function(disk) {
    this.parent();
    this.className = "DockSwapMeter";
    this.swapFileInfo = new SwapFileInfo();
  },
    
  getData: function() {
    if (system.platform == "windows") {
      var mem = this.wmi.Get('Win32_PerfRawData_PerfOS_Memory=@').Properties_;
      var total = mem.Item("CommitLimit").Value;
      var avail = total - mem.Item("CommittedBytes").Value;
    } else {
      var total = system.memory.totalVirtual;
      var avail  = system.memory.availVirtual;
    }            
    return {total: total, avail: avail };
  },
  
  getName: function() {
    return tr("Swap Meter");
  },

  meterName: function() {
    return tr("Swap");
  },

  getValue: function() {
    this.swapFileInfo.getData();
    return this.swapFileInfo.load;
  },

  getHint: function()
  {
    return this.swapFileInfo.getHint();
  },

  doClick: function()
  {
    this.parent();
    if (system.platform == "windows") {
      runCommandInBg("%SystemRoot%/system32/taskmgr.exe", "taskManagerRun");
    }
    if (system.platform == "macintosh") {
      filesystem.open("/Applications/Utilities/Activity Monitor.app");
    }
  }

});

dockFactory.register({name: tr("Swap Meter"),
                      className: "DockSwapMeter",
                      classDef: DockSwapMeter,
                      category: tr("System"),
                      description: tr("Show swap-file usage")
                      });
