
var folderCount = 0;

var psLeft      = 1;
var psRight     = 2;

var TurboFolderPopup = new Class({
  initialize: function(owner) {
    this.owner = owner;
    this.win = null;
    this.name = "folderObj" + folderCount++;
    this.obj = eval(this.name + "=this");
    this.side = 0;
    this.resizeStartPoint = 0;
    this.top = 0;
    this.left = 0;
    this.history = [];
    this.current = null;
    this.maxHeight = Math.round(screen.availHeight * 0.7);
    try {
      this.width = this.owner.widthProp.value || 160;
      this.height = this.owner.heightProp.value || 250;
    } catch(e) {
      this.width = 160;
      this.height = 250;
    }
    if (this.width < 130) {
      this.width = 130;
    }
    if (this.height < 130) {
      this.height = 130;
    }
    this.list = [];

    this.emptyLabel = null;
    this.onShow = function() {};
    this.onHide = function() {};
  },

  createWin: function() {
    if (this.win) return;

    //this.win = new Window("folderPopup");
    this.win = new Window();
    this.win.visible = false;
    this.win.locked = true;
    this.win.shadow = true;
    this.win.level = "topmost";
    this.win.onLoseFocus = this.hide.bind(this);

    // create graphics
    this.bk = new Image(mainWindow);
    this.bk.window = this.win;
    this.bk.src = "Resources/Hint/Fill.png";
    this.bk.colorize = "#000000";
    this.bk.opacity = 200;
    this.bk.zOrder = 1;

    this.leftSide = new Image(mainWindow);
    this.leftSide.window = this.win;
    this.leftSide.src = "Resources/Hint/Fill.png";
    this.leftSide.colorize = "#000000";
    this.leftSide.opacity = 200;
    this.leftSide.hAlign = "left";
    this.leftSide.vAlign = "top";
    this.leftSide.zOrder = 1;

    this.leftTop = new Image(mainWindow);
    this.leftTop.window = this.win;
    this.leftTop.src = "Resources/Hint/TopLeft.png";
    this.leftTop.colorize = "#000000";
    this.leftTop.opacity = 200;
    this.leftTop.hAlign = "left";
    this.leftTop.vAlign = "top";
    this.leftTop.zOrder = 1;

    this.rightTop = new Image(mainWindow);
    this.rightTop.window = this.win;
    this.rightTop.src = "Resources/Hint/TopRight.png";
    this.rightTop.colorize = "#000000";
    this.rightTop.opacity = 200;
    this.rightTop.hAlign = "right";
    this.rightTop.vAlign = "top";
    this.rightTop.zOrder = 1;

    this.rightSide = new Image(mainWindow);
    this.rightSide.window = this.win;
    this.rightSide.src = "Resources/Hint/Fill.png";
    this.rightSide.colorize = "#000000";
    this.rightSide.opacity = 200;
    this.rightSide.hAlign = "left";
    this.rightSide.vAlign = "top";
    this.rightSide.zOrder = 1;

    this.leftBot = new Image(mainWindow);
    this.leftBot.window = this.win;
    this.leftBot.src = "Resources/Hint/BotLeft.png";
//    this.leftBot.src = "Resources/Hint/Fill.png";
    this.leftBot.colorize = "#000000";
    this.leftBot.opacity = 200;
    this.leftBot.hAlign = "left";
    this.leftBot.vAlign = "bottom";
    this.leftBot.zOrder = 1;

    this.rightBot = new Image(mainWindow);
    this.rightBot.window = this.win;
    this.rightBot.src = "Resources/Hint/BotRight.png";
    this.rightBot.colorize = "#000000";
    this.rightBot.opacity = 200;
    this.rightBot.hAlign = "right";
    this.rightBot.vAlign = "bottom";
    this.rightBot.zOrder = 1;

    this.pointer = new Image(mainWindow);
    this.pointer.window = this.win;
    this.pointer.src = "Resources/Hint/Fill.png";
    this.pointer.colorize = "#000000";
    this.pointer.opacity = 200;
    this.pointer.hAlign = "left";
    this.pointer.vAlign = "top";
    this.pointer.width = 28;
    this.pointer.height = dockObj.h + 5;
    this.pointer.zOrder = 1;

    this.image = new Image(mainWindow);
    this.image.window = this.win;
    this.image.src = this.owner.getFolderImage();
    this.image.width = 21;
    this.image.height = 21;
    this.image.tracking = "rectangle";
    this.image.useFileIcon = false;
    this.image.zOrder = 2;
    this.image.onMouseDown = this.iconDown.bind(this);
    this.image.onMouseUp = this.iconUp.bind(this);

    this.hresize = new Image(mainWindow);
    this.hresize.window = this.win;
    this.hresize.src = "Resources/UI/h-resize.png";
    this.hresize.width = 3;
    this.hresize.height = 12;
    this.hresize.tracking = "rectangle";
    this.hresize.opacity = 160;
    this.hresize.zOrder = 2;
    this.hresize.onMouseDown = this.beginResizing.bindAsEventListener(this, [true]);
    this.hresize.onMouseDrag = this.resizing.bindAsEventListener(this, [true]);
    this.hresize.onMouseUp = this.endResizing.bindAsEventListener(this, [true]);

    this.vresize = new Image(mainWindow);
    this.vresize.window = this.win;
    this.vresize.src = "Resources/UI/v-resize.png";
    this.vresize.width = 14;
    this.vresize.height = 3;
    this.vresize.tracking = "rectangle";
    this.vresize.opacity = 140;
    this.vresize.zOrder = 2;
    this.vresize.onMouseDown = this.beginResizing.bindAsEventListener(this, [false]);
    this.vresize.onMouseDrag = this.resizing.bindAsEventListener(this, [false]);
    this.vresize.onMouseUp = this.endResizing.bindAsEventListener(this, [false]);

//    this.createChilds();

    this.captionFrame = new Frame(mainWindow);
    this.captionFrame.window = this.win;
    this.captionFrame.hOffset = 6;
    this.captionFrame.vOffset = 6;
    this.captionFrame.width = this.bk.width;
    this.captionFrame.height = 22;
    this.captionFrame.zOrder = 3;

    this.caption = new Text(mainWindow);
    this.captionFrame.addSubview(this.caption);
    this.caption.hOffset = 0;
    this.caption.vOffset = 15;
    this.caption.width = this.captionFrame.width;
    this.caption.height = 18;
    this.caption.truncation = "end";
    //this.caption.style.fontFamily = $font(preferences.popupTextFont.value);
    $$font(this.caption, preferences.popupTextFont.value, preferences.popupTextFontStyle.value);
    this.caption.style.fontSize = (parseInt(preferences.popupTextSize.value) + 1) + "px";
    this.caption.style.color = preferences.popupTextColor.value;
    //this.caption.style.fontWeight = "bold";
    this.caption.onMouseUp = this.openCurrentFolder.bindAsEventListener(this);

    this.captionLine = new Image(mainWindow);
    this.captionFrame.addSubview(this.captionLine);
    this.captionLine.src = "Resources/Hint/Fill.png";
    this.captionLine.vOffset = 20;
    this.captionLine.width = this.captionFrame.width;
    this.captionLine.height = 2;
    this.captionLine.colorize = preferences.popupStrongTextColor.value;
    this.captionLine.opacity = 220;

    this.backBtn = new Image(mainWindow);
    this.captionFrame.addSubview(this.backBtn);
    this.backBtn.opacity = 210;
    this.backBtn.vOffset = 4;
    var isDark = !Color.isLightColor(Color.HexToRGB(preferences.popupColor.value));
    this.backBtn.src = "Resources/Sensors/BackBtn-" + (isDark?"Black":"White") + ".png";
    this.backBtn.tracking = "rectangle";
    this.backBtn.onMouseUp = this.back.bind(this);
    this.backBtn.visible = false;

    this.browserContainer = new Frame(mainWindow);
    this.browserContainer.window = this.win;
    this.browserContainer.hOffset = 6;
    this.browserContainer.vOffset = this.captionFrame.vOffset + this.captionFrame.height + 2;
    this.browserContainer.width = this.bk.width;
    this.browserContainer.height = this.bk.height - this.browserContainer.vOffset;
    this.browserContainer.zOrder = 3;

    this.browser = new Frame(mainWindow);
    //this.browser.window = this.win;
    this.browserContainer.addSubview(this.browser);
    //this.browser.hOffset = 4;
    //this.browser.vOffset = this.captionFrame.vOffset + this.captionFrame.height + 2;
    this.browser.width = this.bk.width;
    this.browser.height = this.browserContainer.height - this.browser.vOffset;

    this.browser.onMouseWheel = this.wheelScroll.bindAsEventListener(this);

    this.listSel = new Image();
    this.browser.addSubview(this.listSel);
    this.listSel.hOffset = 0;
    this.listSel.src = "Resources/Sensors/Fill.png";
//    this.listSel.colorize = "#2580BB";
    var isDark = !Color.isLightColor(Color.HexToRGB(preferences.popupColor.value));
    this.listSel.colorize = isDark?"#A9DFFF":"#00649E";
    this.listSel.opacity = isDark?100:140;
    this.listSel.height = 20;
    this.listSel.vOffset = -2;
    this.listSel.visible = false;

    this.browserScrollbar = new ScrollBar();
    this.browserScrollbar.window = this.win;
    this.browserScrollbar.vOffset = this.browserContainer.vOffset;
    this.browserScrollbar.autoHide = true;
    this.browserScrollbar.orientation = "vertical";
    //this.browserScrollbar.thumbColor = "#2580BB";
    //this.browserScrollbar.thumbColor = preferences.popupStrongTextColor.value;
    this.browserScrollbar.thumbColor = "#444444";
    this.browser.vScrollBar = this.browserScrollbar;
    this.browserScrollbar.zOrder = 3;

    this.loading = new Image(mainWindow);
    this.loading.window = this.win;
    this.loading.src = "Resources/Sensors/Fill.png";
    this.loading.visible = false;
    this.loading.width = 12;
    this.loading.height = 5;
    this.loading.zOrder = 3;

    this.keyCapture = new TextArea();
    this.keyCapture.window = this.win;
    this.keyCapture.opacity = 0;
    this.keyCapture.onKeyUp = this.keyHandler.bindAsEventListener(this);
    this.keyCapture.onLoseFocus = this.hide.bind(this);

    //this.win.onGainFocus = this.windowGainFocus.bind(this);

    this.resize();
  },

  /*windowGainFocus: function() {
    this.keyCapture.focus();
  },*/

  keyHandler: function(event) {
    switch(event.keyCode) {
      case 27 /*Escape*/:
        this.hide();
        break;
      case 8/*Backspace*/:
        if (this.backBtn.visible) this.back();
        break;
    }
  },

  beginResizing: function(event, isHoriz) {
    this.resizeStartPoint = (isHoriz) ? event.x : event.y;
  },

  resizing: function(event, isHoriz) {
    if (isHoriz) {
      this.top = 0;
      if (this.side == psRight) {
        this.width = Math.max(130, event.hOffset - 6 - this.resizeStartPoint);
        if (this.width > 400) {
          this.width = 400;
        }
      } else {
        this.left = this.win.hOffset + (event.hOffset - this.resizeStartPoint);
        this.width = this.width - (event.hOffset - this.resizeStartPoint);
        if (this.width < 130) {
          this.width = 130;
          this.left = (mainWindow.hOffset + this.owner.frame.hOffset) - this.win.width + this.owner.frame.width + 5;
        }
        if (this.width > 400) {
          this.width = 400;
          this.left = (mainWindow.hOffset + this.owner.frame.hOffset) - this.win.width + this.owner.frame.width + 5;
        }
      }
    } else {
      this.left = 0;

      if (preferences.position.value == 2) {
        this.top = this.win.vOffset + (event.vOffset - this.resizeStartPoint);
        this.height = this.height - (event.vOffset - this.resizeStartPoint);
        if (this.height < 130) {
          this.height = 130;
          this.top = this.getWindowTop();
        }
        if (this.height > this.maxHeight) {
          this.height = this.maxHeight;
          this.top = this.getWindowTop();
        }
      } else {
        this.top = 0;
        this.height = Math.max(130, event.vOffset - this.pointer.height - this.resizeStartPoint);
        if (this.height > this.maxHeight) {
          this.height = this.maxHeight;
        }
      }
    }
    this.resize();
  },

  endResizing: function(event, isHoriz) {
    this.resizeStartPoint = 0;
    this.left = 0;
    this.top = 0;

    this.owner.widthProp.value = this.width;
    this.owner.heightProp.value = this.height;
    dockObj.save();
  },

  resize: function() {
    suppressUpdates();
    try {
      var vOffset = (preferences.position.value == 2)?6:this.pointer.height;
      
      if (this.left != 0) {
        this.win.hOffset = this.left;
      }
      if (this.top != 0) {
        this.win.vOffset = this.top;
      }

      this.bk.hOffset = 6;
      this.bk.vOffset = vOffset;
      this.bk.width = this.width;
      this.bk.height = this.height;

      this.pointer.hOffset = (this.side == psRight)?0:(this.bk.width - this.pointer.width);
      this.pointer.vOffset = (preferences.position.value == 2)?(this.bk.vOffset + this.bk.height):0;

      this.image.hOffset = 4;
      this.image.vOffset = this.pointer.vOffset + ((preferences.position.value == 2)?8:3);

      this.leftTop.hOffset = 0;
      this.leftTop.vOffset = this.bk.vOffset;

      this.rightTop.hOffset = this.bk.hOffset + this.bk.width + this.rightTop.width;
      this.rightTop.vOffset = this.bk.vOffset;

      this.leftBot.hOffset = 0;
      this.leftBot.vOffset = this.bk.vOffset + this.bk.height;

      this.rightBot.hOffset = this.bk.hOffset + this.bk.width + this.rightBot.width;
      this.rightBot.vOffset = this.bk.vOffset + this.bk.height;

      this.leftSide.hOffset = 0;
      this.leftSide.vOffset = this.leftTop.vOffset + this.leftTop.height;
      this.leftSide.height = this.bk.height - this.leftTop.height - this.leftBot.height;

      this.rightSide.hOffset = this.bk.hOffset + this.bk.width;
      this.rightSide.vOffset = this.rightTop.vOffset + this.rightTop.height;
      this.rightSide.height = this.bk.height - this.rightTop.height - this.rightBot.height;

      this.hresize.hOffset = this.bk.hOffset + this.bk.width + 2;
      this.hresize.vOffset = Math.round((this.bk.vOffset * 2 + this.bk.height - this.hresize.height) / 2);

      this.vresize.hOffset = Math.round((this.bk.hOffset * 2 + this.bk.width - this.vresize.width) / 2);
      this.vresize.vOffset = (preferences.position.value == 2)?(this.bk.vOffset + 1):(this.bk.vOffset + this.bk.height - this.vresize.height - 1);

      if (this.side == psLeft) {
        this.hresize.hOffset = this.bk.hOffset - 5;
      }
      this.pointer.hOffset = (this.side == psRight)?0:(this.bk.width - this.pointer.width + 12);
      this.image.hOffset = (this.side == psRight)?4:(this.bk.width - this.pointer.width + /*14*/16);

      this.loading.hOffset = this.bk.hOffset + Math.round((this.bk.width - this.loading.width) / 2);
      this.loading.vOffset = this.bk.vOffset + Math.round((this.bk.height - this.loading.height) / 2);

      this.captionFrame.vOffset = (preferences.position.value == 2)?8:(this.pointer.vOffset + this.pointer.height);
      this.captionFrame.width = this.bk.width;
      this.caption.width = this.captionFrame.width - this.backBtn.width - 5;
      this.captionLine.width = this.captionFrame.width;
      this.backBtn.hOffset = this.captionFrame.width - this.backBtn.width;

      this.browserContainer.vOffset = this.captionFrame.vOffset + this.captionFrame.height + 2;
      this.browserContainer.width = this.bk.width - 3;
      this.browserContainer.height = this.bk.height - this.browserContainer.vOffset + ( (preferences.position.value == 2)?0:(this.captionFrame.height/* + 6*/) );

      //this.browser.vOffset = this.captionFrame.vOffset + this.captionFrame.height + 2;
      this.browser.width = this.browserContainer.width - 3;
      this.browser.height = this.browserContainer.height - this.browser.vOffset + ( (preferences.position.value == 2)?0:(this.captionFrame.height/* + 6*/) );
      
      this.listSel.width = this.browserContainer.width;
      this.browserScrollbar.vOffset = this.browserContainer.vOffset - 1;
      this.browserScrollbar.hOffset = this.browserContainer.hOffset + this.browserContainer.width - this.browserScrollbar.width + 5;
      this.browserScrollbar.height = this.browserContainer.height + 1;

      for (var i = 0; i < this.list.length; i++) {
        this.setListItemWidth(this.list[i], this.browser.width);
      }

      if (this.emptyLabel) {
        this.emptyLabel.vOffset = Math.round((this.browser.height - this.emptyLabel.height) / 2);
        this.emptyLabel.width = this.browser.width - 5;
      }
    } finally {
      resumeUpdates();
    }
  },

  show: function() {
    this.history = [];
    if (!this.win) this.createWin();

    this.folder = this.owner.folderProp.value;
    if (!["/", "\\"].test(this.folder.substr(this.folder.length - 1, 1))) {
      this.folder += "/";
    }
    //this.caption.data = this.owner.folderProp.value.extractFileName();
    //this.caption.data = filesystem.getDisplayName(this.folder);
    this.caption.data = this.owner.getFolderTitle();
    this.current = this.owner.folderProp.value;

    var _x = mainWindow.hOffset + this.owner.frame.hOffset;
    var _y = this.getWindowTop();

    this.side = psRight;

    if ((_x + this.win.width + 10) >= screen.availWidth) {
      _x = _x - this.win.width + this.owner.frame.width /*+ 5*/;
      this.side = psLeft;
    }

    if (preferences.position.value == 2) {
      if (this.side == psRight) {
        this.leftBot.src = "Resources/Hint/Fill.png";
      } else {
        this.rightBot.src = "Resources/Hint/Fill.png";
        this.hresize.hOffset = this.bk.hOffset - 5;
      }
    } else {
      if (this.side == psRight) {
        this.leftTop.src = "Resources/Hint/Fill.png";
      } else {
        this.rightTop.src = "Resources/Hint/Fill.png";
        this.hresize.hOffset = this.bk.hOffset - 5;
      }
    }
    this.pointer.hOffset = (this.side == psRight)?0:(this.bk.width - this.pointer.width + 12);
    this.image.hOffset = (this.side == psRight)?4:(this.bk.width - this.pointer.width + /*14*/16);

    this.win.hOffset = _x;
    this.win.vOffset = _y;

    this.image.opacity = this.owner.opacityProp.value;
    this.image.colorize = this.owner.colorizeProp.colorize();

    this.showLoading();

    this.bk.colorize = this.pointer.colorize = this.leftSide.colorize =
      this.rightSide.colorize = this.leftTop.colorize = this.rightTop.colorize =
      this.leftBot.colorize = this.rightBot.colorize = preferences.popupColor.value;
    this.bk.opacity = this.pointer.opacity = this.leftSide.opacity =
      this.rightSide.opacity = this.leftTop.opacity = this.rightTop.opacity =
      this.leftBot.opacity = this.rightBot.opacity = parseInt(preferences.popupOpacity.value);

    var isDark = !Color.isLightColor(Color.HexToRGB(preferences.popupColor.value));
    this.hresize.colorize = this.vresize.colorize = isDark?"#FFFFFF":"#000000";

    this.win.recalcShadow();
    this.win.opacity = 0;
    this.win.visible = true;
    this.win.opacity = 255;
    this.win.focus();

    this.doShow();
  },

  doShow: function() {
    this.onShow();
    this.keyCapture.focus();
    this.buildList();
  },

  hide: function() {
    this.win.opacity = 0;
    this.win.visible = false;

    this.onHide();
  },

  getWindowTop: function() {
    return ( (parseInt(preferences.position.value) != 1) ?
                (mainWindow.vOffset + mainWindow.height - this.win.height) :
                 mainWindow.vOffset );
  },

  showLoading: function() {
    var isDark = !Color.isLightColor(Color.HexToRGB(preferences.popupTextColor.value));
    this.loading.visible = true;
    this.loading.src = "Resources/Sensors/Loading" + (isDark?"-Dark":"") + ".gif"; // TODO: use '-dark' if bright background
  },

  hideLoading: function() {
    this.loading.src = "Resources/Sensors/Fill.png";
    this.loading.visible = false;
  },

  iconDown: function() {
    this.image.opacity -= 100;
  },

  iconUp: function() {
    this.image.opacity += 100;
    this.hide();
  },

  clear: function() {
    for (var i in this.list) {
      if (typeof(this.list[i]) == 'function') continue;
      try {
        this.list[i].icon.removeFromSuperview();
        delete this.list[i].icon;
        this.list[i].label.removeFromSuperview();
        delete this.list[i].label;
        this.list[i].frame.removeFromSuperview();
        delete this.list[i].frame;
      } catch(e) {}
   }
   this.list = [];
  },

  createItem: function(item, isFolder) {
    var result = {};
    result.frame = new Frame();
    this.browser.addSubview(result.frame);
    result.frame.hOffset = 0;
    result.frame.vOffset = 0;
    result.frame.width = this.browser.width;
    if (isFolder) {
      result.frame.onMouseUp = this.browseFS.bind(this, item + '/');
    } else {
      result.frame.onMouseUp = this.openFS.bindAsEventListener(this, [item + (isFolder?'/':'')]);
    }

    var isURL = item.match(/\.url$/i);

    result.icon = new Image();
    result.frame.addSubview(result.icon);
    result.icon.hOffset = 0;
    result.icon.vOffset = 0;
    result.icon.width = 16;
    result.icon.height = 16;
//    result.icon.src = isFolder?"Resources/Sensors/Popup-Folder.png":"Resources/Sensors/Popup-File.png";
    result.icon.src = isFolder?"Resources/Sensors/Popup-Folder.png":(!isURL?(item):"Resources/Sensors/Popup-Web.png");
    result.icon.missingSrc = "Resources/Sensors/Popup-Web.png";
    result.icon.useFileIcon = !isFolder && !isURL;

//    result.icon.src = this.folder + item;
//    result.icon.useFileIcon = true;

    result.label = new Text();
    result.frame.addSubview(result.label);
    result.label.style.fontFamily = "Calibri, Arial, Helvetica";
    result.label.style.fontWeight = "bold";
    result.label.style.color = preferences.popupTextColor.value;
    result.label.style.fontSize = "12px";
    result.label.hOffset = 20;
    result.label.vOffset = 13;
    result.label.width = result.frame.width - 30/*50*/;
    result.label.truncation = "end";
    //result.label.data = filesystem.getDisplayName(item);
    result.label.data = this.getDisplayName(item);

    result.frame.onMouseEnter = this.showSel.bind(this, result);
    result.frame.onMouseExit = this.hideSel.bind(this, result);

    return result;
  },

  filterFS: function(item) {
    if (system.platform == "macintosh") {
      if (item.match(/\.DS_Store$/ig)) return false;
      if (item.match(/\.localized$/ig)) return false;
    }
    if (system.platform == "windows") {
      if (item.match(/desktop\.ini$/ig)) return false;
    }
    return true;
  },

  getItems: function(folder) {
    try {
      return filesystem.getDirectoryContents((folder || this.folder) + ".");
    } catch(e) {
      return [];
    }
  },

  getFoldersAndFiles: function(folder) {
    var items = this.getItems(folder);

    var folders = [];
    var files = [];
    for (var i = 0; i < items.length; i++) {
          var item = ((system.platform == "windows")?"":(folder || this.folder)) + items[i];
      if (!filesystem.itemExists(item)) continue;
      if (item.trim() == "") continue;
      if (!this.filterFS(item)) continue;
      var info = filesystem.getFileInfo(item);
      var isFolder = info.isDirectory;
      if (isFolder && (system.platform == "macintosh") && (item.match(/\.app$/ig))) {
            isFolder = false;
      }
      if (isFolder) {
        folders.push(item);
      } else {
        files.push(item);
      }
    }

    return {folders: folders, files: files};
  },

  sortByName: function(item1, item2) {
    var file1 = item1.extractFileName();
    var file2 = item2.extractFileName();
    if (file1 < file2) {
      return -1;
    }
    return (file1 > file2) ? 1 : 0;
  },

  buildList: function(folder) {
    //suppressUpdates();
    try {
      this.browser.visible = false;
      
      var data = this.getFoldersAndFiles(folder);

      this.clear();

      data.folders.sort(this.sortByName);
      data.files.sort(this.sortByName);

      if ((data.folders.length == 0) && (data.files.length == 0) && (!this.emptyLabel)) {
        this.emptyLabel = new Text();
        this.browser.addSubview(this.emptyLabel);
        this.emptyLabel.anchorStyle = "topLeft";
        this.emptyLabel.style.fontFamily = "Calibri, Arial, Helvetica";
        this.emptyLabel.style.fontWeight = "bold";
        this.emptyLabel.style.color = preferences.popupTextColor.value;
        this.emptyLabel.style.fontSize = "12px";
        this.emptyLabel.hOffset = Math.round((this.browser.width - this.emptyLabel.width) / 2);
        this.emptyLabel.vOffset = Math.round((this.browser.height - this.emptyLabel.height) / 2);
        this.emptyLabel.width = this.browser.width - 5;
        this.emptyLabel.hAlign = "center";
        this.emptyLabel.data = tr("no items");
      } else {
        if (this.emptyLabel) {
          this.emptyLabel.removeFromSuperview();
          delete this.emptyLabel;
          this.emptyLabel = null;
        }

        for (var i = 0; i < data.folders.length; i++) {
          this.list.push(this.createItem(data.folders[i], true));
        }
        for (var i = 0; i < data.files.length; i++) {
          this.list.push(this.createItem(data.files[i], false));
        }
      }

      this.alignList();
    } finally {
      this.browser.visible = true;
      this.hideLoading();
      //resumeUpdates();
      this.browser.width = this.browserScrollbar.visible?(this.bk.width - 3):(this.bk.width + 3);
      this.listSel.width = this.browser.width;

      this.listSel.vOffset = -2;
      this.listSel.visible = (data.folders.length != 0) || (data.files.length != 0);
    }
  },

  alignList: function() {
    var y = 0;
    for (var i = 0; i < this.list.length; i++) {
      this.list[i].frame.vOffset = y;
      y += 20;
    }
  },

  setListItemWidth: function(item, width) {
    item.frame.width = width;
    item.label.width = item.frame.width - 30/*50*/;
  },

  showSel: function(item) {
    if (!item) return;
    this.listSel.vOffset = item.frame.vOffset - 2;
    this.listSel.visible = true;
  },

  hideSel: function(item) {
    this.listSel.visible = false;
  },

  openFS: function(event, item) {
    this.hide();
    if (event.altKey) {
      filesystem.reveal(item);
    } else {
      if (item.match(/\.lnk$/i)) {
        runCommandInBg(item, "TurboFolder");
      } else {
        filesystem.open(item);
      }
    }
  },

  browseFS: function(item, isBack) {
    if (isBack != true) {
      this.history.push(item);
    }
    this.backBtn.visible = (this.history.length > 0);

    this.caption.data = this.backBtn.visible?this.getDisplayName(item):this.owner.getFolderTitle();
    this.current = this.backBtn.visible?item:this.owner.folderProp.value;
    
    if (isBack != true) {
      var a = new MoveAnimation(this.browser, -this.browser.width, this.browser.vOffset, 250, animator.kEaseOut);
    } else {
      var a = new MoveAnimation(this.browser, this.browser.hOffset + this.browser.width, this.browser.vOffset, 250, animator.kEaseOut);
    }
    animator.runUntilDone(a);
    this.clear();
    this.browser.home();
    this.listSel.vOffset = 0;
    this.browser.hOffset = 0;

    this.buildList(item);
  },

  back: function() {
    if (this.history.length <= 0) return;
    this.history.pop();
    var path = this.history[this.history.length - 1];
    this.browseFS(path, true);
  },

  getDisplayName: function(path) {
    var tmp = path.split("/");
    if (tmp[tmp.length - 1] == "") tmp.pop();
    var s = (tmp.length > 0)?tmp.pop():filesystem.getDisplayName(path);
    if (system.platform == "windows") {
      s = s.replace(/\.lnk/ig, "");
      s = s.replace(/\.url/ig, "");
    }
    if (system.platform == "macintosh") {
      s = s.replace(/\.app/ig, "");
    }
    return s;
  },

  openCurrentFolder: function(event) {
    this.hide();
    if (event.altKey) {
      filesystem.reveal(this.current);
    } else {
      filesystem.open(this.current);
    }
  },

  wheelScroll: function(event) {
    if (event.scrollDelta < 0) {
      for (var i = 0; i < Math.abs(event.scrollDelta); i++) {
        this.browser.lineDown();
      }
    }
    if (event.scrollDelta > 0) {
      for (var i = 0; i < event.scrollDelta; i++) {
        this.browser.lineUp();
      }
    }
  }

});
