
include("Sensors/TurboFolderStartMenuPopup.js");

var TurboFolderStartMenu = TurboFolder.extend({
  initialize: function() {
    this.parent();
    this.className = "TurboFolderStartMenu";
    
    this.props = [this.textProp, this.imageProp, this.colorizeProp,
                  this.opacityProp, this.widthProp, this.heightProp];
  },

  createPopup: function() {
    return new TurboFolderStartMenuPopup(this);
  },

  getFolderTitle: function() {
    return (this.textProp.value != "")?this.textProp.value:tr((system.platform == "windows")?"Start Menu":"Applications");
  },

  getFolderImage: function() {
    return ( (this.imageProp.value != "")?this.imageProp.value:"Resources/Sensors/Folder-" + ((system.platform == "windows")?"Win":"Mac") + ".png" );
  },

  getName: function() {
    return tr("TurboFolder") + ": " + tr((system.platform == "windows")?"Start Menu":"Applications");
  },

  getTitle: function() {
    return tr((system.platform == "windows")?"Start Menu":"Applications");
  },

  getHint: function() {
    return ( ((this.popup == null) && !this.lockedPopup) ? ( (this.getFolderTitle()) ) : "" );
  },

  sensorMenuItems: function(items) {
    this.parent(items);

    var item = new MenuItem();
    item.title = tr("Open (all users) folder");
    item.onSelect = this.doOpenAllUsers.bind(this);
    items.push(item);
  },

  doOpen: function() {
    filesystem.open(dockObj.folders["Programs"]);
  },

  doOpenAllUsers: function() {
    filesystem.open(dockObj.folders["Common Programs"]);
  }

});

dockFactory.register({name: tr("TurboFolder") + ": " + tr((system.platform == "windows")?"Start Menu":"Applications"),
                      className: "TurboFolderStartMenu",
                      classDef: TurboFolderStartMenu,
                      category: tr("System"),
                      description: (system.platform == "windows")?tr("Display Start Menu content"):tr("Display Applications folder content")
                      });
