
var DockUSB = DockBase.extend({
  initialize: function() {
    this.parent();
    this.className = "DockUSB";
    this.image = null;

    this.opacityProp = new OpacityProp("opacity", "Opacity:", 255, 50);
    
    this.props = [this.opacityProp];
  },

  destroy: function() {
    if (this.parent()) {
      this.image = null;
    }
  },

  updateProps: function(loaded) {
    if (!this.image) return;
    this.image.opacity = this.opacityProp.value;
  },

  getName: function() {
    return tr("Eject USB");
  },

  createControls: function() {
    if (this.parent()) {
      this.image = new Image(mainWindow);
      this.frame.addSubview(this.image);
      this.image.src = "Resources/Sensors/USB.png";
      this.image.hOffset = 0;
      this.image.vOffset = 2;
      this.image.width = 30;
      this.image.height = 21;
      this.image.tracking = "rectangle";
      this.image.useFileIcon = false;

      this.updateProps();
    }
    return (this.frame != null);
  },

  getTitle: function() {
    return tr("Eject USB");
  },

  getHint: function() {
    return tr("Eject USB");
  },

  doClick: function() {
    this.parent();

    if (system.platform == "windows") {
      runCommandInBg("RunDll32.EXE shell32.dll,Control_RunDLL hotplug.dll", "USBTools");
    } else {
      //alert("Not yet available on Macintosh.");
      /*appleScript("tell application \"Finder\"\n" +
                  "set the_disk to (choose from list (list disks) with prompt \"Choose a volume to eject:\") as string\n" +
                  "if the_disk = \"false\" then return\n" +
                  "eject disk the_disk\n" +
                  "end tell");*/
      appleScript("tell application \"Finder\"\n" +
"        set remote_disks to (name of every disk whose local volume is true and ejectable is true) as list\n" +
"        try\n" +
"                if remote_disks is missing value then\n" +
"                        display dialog \"Nothing to eject\" buttons {\"OK\"}\n" +
"                else\n" +
"                        set the_disk to (choose from list remote_disks with prompt \"Choose a volume to eject:\") as string\n" +
"                        if the_disk = \"false\" then return\n" +
"                        eject disk the_disk\n" +
"                end if\n" +
"        on error errMsg number errNum\n" +
"                display dialog \"Nothing to eject\" buttons {\"OK\"}\n" +
"        end try\n" +
"end tell");
    }
  }
});

dockFactory.register({name: tr("Eject USB"),
                      className: "DockUSB",
                      classDef: DockUSB,
                      category: tr("System"),
                      description: tr("Eject USB devices")
                      });
