
include("Sensors/YMailHint.js");

var DockYMail = DockGenericMail.extend({
  initialize: function() {
    this.parent(tr("Y!Mail"));
    this.className = "DockYMail";
    
    this.isFetchHeaders = false;
    this.props = [this.titleProp, this.intervalProp, this.customIconProp, this.notifyProp];
  },

  getName: function() {
    return tr("Yahoo! Mail Checker");
  },

  doOpenClient: function() {
    if (yahooCheckLogin())
      this.openURL("http://mail.yahoo.com/?fr=kon");
    else
      yahooLogin();
  },

  getIcon: function() {
    return "Resources/Sensors/YMail-Rotated.png";
  },

  createHint: function() {
    this.hint = new YMailHint(this);
  },

  updateValue: function() {
    if (!this.label) return;
    if (this.data == "") {
      this.setHasNews(false);
      this.setStatus("n/a");
      return;
    }
    try {
      x = XMLDOM.parse(this.data);
      if (String(x.evaluate("string(/alerts/mail/@num)")) == "-1") {
        this.setHasNews(false);
        this.setStatus("0");
      } else {
        var cnt = parseInt(String(x.evaluate("string(/alerts/mail/@num)")));
        this.setHasNews(cnt > 0);
        this.setStatus(cnt);
      }
    } catch(e) {
      this.setError("Format error");
    }                       
  },

  updateFeed: function(url) {
    url["caller"].finishChecking();
    var data = url.result;
    if (url.response == 200 && data.length) {
      data = data.replace("<html>", "<?xml version=\"1.0\" encoding=\"utf-8\"?>");
      // work around null character in feed (cross your fingers)
      if (data.indexOf("\0") != -1)
        data = data.substr(0, data.indexOf("\0"));
      url["caller"].data = data;
      url["caller"].lastUpdate = new Date();
      // save cache
      if (url["caller"].cache != "") {
        filesystem.writeFile(url["caller"].cache, data);
      }
      url["caller"].makeElementInactive(url["caller"].icon, false);
      url["caller"].updateValue();
    } else {
      url["caller"].setError("Connection time-out.");
    }
  },

  beforeFetch: function() {
    this.error = false;
    return yahooCheckLogin();
  },

  doFetch: function() {
    //this.parent();
    if (!this.beforeFetch()) return;

    var logged = true;
    if (!yahooCheckLogin()) {
      //logged = yahooLogin();
      logged = false;
    }

    if (!logged) {
      this.setError("Not logged in.");
      return;
    }

    this.startChecking();
    var u = new URL();
    u.location = "http://us.update.toolbar.yahoo.com/slv/v4/not?.x=1";
    u["caller"] = this;
    u.fetchAsync(this.obj.updateFeed);
  },

  signIn: function() {
    if (!yahooCheckLogin()) {
      yahooLogin();
    }
  },

  sensorMenuItems: function(items) {
    //this.parent();

    var item = new MenuItem();
    item.title = (system.platform == "windows")?"-":"(-";
    items.push(item);

    var item = new MenuItem();
    item.title = tr(yahooCheckLogin()?"Check for Mail":"Sign In...");
    if (yahooCheckLogin()) {
      item.onSelect = this.doFetch.bind(this);
    } else {
      item.onSelect = this.signIn.bind(this);
    }
    items.push(item);
  },

  genCacheName: function() {
    return "ymail-" + this.filterUsername(this.usernameProp.value) + ".xml";
  },

  /*setError: function() {
    if (arguments.length > 0) {
      this.parent(arguments[0]);
    } else {
      this.parent();
    }
    if (this.status) {
      this.setStatus("n/a");
    }
  },*/

  filterUsername: function(value) {
    if (!value) return "";
    var a = value.split("@");
    if (a.length > 0) {
      return a[0];
    }
    return "";
  }
});

dockFactory.register({name: tr("Yahoo! Mail Checker"),
                      className: "DockYMail",
                      classDef: DockYMail,
                      category: tr("Internet"),
                      description: tr("Check mail on Yahoo! Mail")
                      });
